/* Utils.c generated by valac 0.42.5, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <NetworkManager.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>

typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_MOBILE,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_MOBILE,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_MOBILE,
	NETWORK_STATE_FAILED_VPN
} NetworkState;


#define NETWORK_TYPE_STATE (network_state_get_type ())

#define NETWORK_TYPE_UTILS (network_utils_get_type ())
#define NETWORK_UTILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_UTILS, NetworkUtils))
#define NETWORK_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_UTILS, NetworkUtilsClass))
#define NETWORK_IS_UTILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_UTILS))
#define NETWORK_IS_UTILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_UTILS))
#define NETWORK_UTILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_UTILS, NetworkUtilsClass))

typedef struct _NetworkUtils NetworkUtils;
typedef struct _NetworkUtilsClass NetworkUtilsClass;
typedef struct _NetworkUtilsPrivate NetworkUtilsPrivate;
typedef enum  {
	NETWORK_UTILS_CUSTOM_MODE_PROXY_NONE = 0,
	NETWORK_UTILS_CUSTOM_MODE_PROXY_MANUAL,
	NETWORK_UTILS_CUSTOM_MODE_PROXY_AUTO,
	NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_ENABLED,
	NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_DISABLED,
	NETWORK_UTILS_CUSTOM_MODE_INVALID
} NetworkUtilsCustomMode;


#define NETWORK_UTILS_TYPE_CUSTOM_MODE (network_utils_custom_mode_get_type ())
typedef enum  {
	NETWORK_UTILS_ITEM_TYPE_DEVICE = 0,
	NETWORK_UTILS_ITEM_TYPE_VIRTUAL,
	NETWORK_UTILS_ITEM_TYPE_INVALID
} NetworkUtilsItemType;


#define NETWORK_UTILS_TYPE_ITEM_TYPE (network_utils_item_type_get_type ())
typedef void (*NetworkUtilsUpdateSecretCallback) (gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NetworkParamSpecUtils NetworkParamSpecUtils;

struct _NetworkUtils {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NetworkUtilsPrivate * priv;
};

struct _NetworkUtilsClass {
	GTypeClass parent_class;
	void (*finalize) (NetworkUtils *self);
};

struct _Block1Data {
	int _ref_count_;
	NMRemoteConnection* connection;
	NetworkUtilsUpdateSecretCallback callback;
	gpointer callback_target;
};

struct _NetworkParamSpecUtils {
	GParamSpec parent_instance;
};


static gpointer network_utils_parent_class = NULL;

GType network_state_get_type (void) G_GNUC_CONST;
gchar* network_state_to_string (NetworkState self);
#define NETWORK_UNKNOWN_STR _ ("Unknown")
gpointer network_utils_ref (gpointer instance);
void network_utils_unref (gpointer instance);
GParamSpec* network_param_spec_utils (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void network_value_set_utils (GValue* value,
                              gpointer v_object);
void network_value_take_utils (GValue* value,
                               gpointer v_object);
gpointer network_value_get_utils (const GValue* value);
GType network_utils_get_type (void) G_GNUC_CONST;
GType network_utils_custom_mode_get_type (void) G_GNUC_CONST;
GType network_utils_item_type_get_type (void) G_GNUC_CONST;
void network_utils_update_secrets (NMRemoteConnection* connection,
                                   NetworkUtilsUpdateSecretCallback callback,
                                   gpointer callback_target);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda4_ (Block1Data* _data1_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda4__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
gboolean network_utils_get_device_is_hotspot (NMDeviceWifi* wifi_device);
gboolean network_utils_get_connection_is_hotspot (NMConnection* connection);
gchar* network_utils_state_to_string (NMDeviceState state);
gchar* network_utils_type_to_string (NMDeviceType type);
NetworkUtils* network_utils_new (void);
NetworkUtils* network_utils_construct (GType object_type);
static void network_utils_finalize (NetworkUtils * obj);


gchar*
network_state_to_string (NetworkState self)
{
	gchar* result = NULL;
#line 41 "../src/Utils.vala"
	switch (self) {
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_DISCONNECTED:
#line 165 "Utils.c"
		{
			gchar* _tmp0_;
#line 43 "../src/Utils.vala"
			_tmp0_ = g_strdup (_ ("Disconnected"));
#line 43 "../src/Utils.vala"
			result = _tmp0_;
#line 43 "../src/Utils.vala"
			return result;
#line 174 "Utils.c"
		}
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_WIFI:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_WIFI_WEAK:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_WIFI_OK:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_WIFI_GOOD:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_WIFI_EXCELLENT:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_WIRED:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_VPN:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTED_MOBILE:
#line 192 "Utils.c"
		{
			gchar* _tmp1_;
#line 52 "../src/Utils.vala"
			_tmp1_ = g_strdup (_ ("Connected"));
#line 52 "../src/Utils.vala"
			result = _tmp1_;
#line 52 "../src/Utils.vala"
			return result;
#line 201 "Utils.c"
		}
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_FAILED_WIRED:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_FAILED_WIFI:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_FAILED_VPN:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_FAILED_MOBILE:
#line 211 "Utils.c"
		{
			gchar* _tmp2_;
#line 57 "../src/Utils.vala"
			_tmp2_ = g_strdup (_ ("Failed"));
#line 57 "../src/Utils.vala"
			result = _tmp2_;
#line 57 "../src/Utils.vala"
			return result;
#line 220 "Utils.c"
		}
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTING_WIFI:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTING_WIRED:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTING_VPN:
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_CONNECTING_MOBILE:
#line 230 "Utils.c"
		{
			gchar* _tmp3_;
#line 62 "../src/Utils.vala"
			_tmp3_ = g_strdup (_ ("Connecting"));
#line 62 "../src/Utils.vala"
			result = _tmp3_;
#line 62 "../src/Utils.vala"
			return result;
#line 239 "Utils.c"
		}
#line 41 "../src/Utils.vala"
		case NETWORK_STATE_WIRED_UNPLUGGED:
#line 243 "Utils.c"
		{
			gchar* _tmp4_;
#line 64 "../src/Utils.vala"
			_tmp4_ = g_strdup (_ ("Cable unplugged"));
#line 64 "../src/Utils.vala"
			result = _tmp4_;
#line 64 "../src/Utils.vala"
			return result;
#line 252 "Utils.c"
		}
		default:
		{
			gchar* _tmp5_;
#line 66 "../src/Utils.vala"
			_tmp5_ = g_strdup (NETWORK_UNKNOWN_STR);
#line 66 "../src/Utils.vala"
			result = _tmp5_;
#line 66 "../src/Utils.vala"
			return result;
#line 263 "Utils.c"
		}
	}
}


GType
network_state_get_type (void)
{
	static volatile gsize network_state_type_id__volatile = 0;
	if (g_once_init_enter (&network_state_type_id__volatile)) {
		static const GEnumValue values[] = {{NETWORK_STATE_DISCONNECTED, "NETWORK_STATE_DISCONNECTED", "disconnected"}, {NETWORK_STATE_WIRED_UNPLUGGED, "NETWORK_STATE_WIRED_UNPLUGGED", "wired-unplugged"}, {NETWORK_STATE_CONNECTED_WIRED, "NETWORK_STATE_CONNECTED_WIRED", "connected-wired"}, {NETWORK_STATE_CONNECTED_VPN, "NETWORK_STATE_CONNECTED_VPN", "connected-vpn"}, {NETWORK_STATE_CONNECTED_MOBILE, "NETWORK_STATE_CONNECTED_MOBILE", "connected-mobile"}, {NETWORK_STATE_CONNECTED_WIFI, "NETWORK_STATE_CONNECTED_WIFI", "connected-wifi"}, {NETWORK_STATE_CONNECTED_WIFI_WEAK, "NETWORK_STATE_CONNECTED_WIFI_WEAK", "connected-wifi-weak"}, {NETWORK_STATE_CONNECTED_WIFI_OK, "NETWORK_STATE_CONNECTED_WIFI_OK", "connected-wifi-ok"}, {NETWORK_STATE_CONNECTED_WIFI_GOOD, "NETWORK_STATE_CONNECTED_WIFI_GOOD", "connected-wifi-good"}, {NETWORK_STATE_CONNECTED_WIFI_EXCELLENT, "NETWORK_STATE_CONNECTED_WIFI_EXCELLENT", "connected-wifi-excellent"}, {NETWORK_STATE_CONNECTING_WIFI, "NETWORK_STATE_CONNECTING_WIFI", "connecting-wifi"}, {NETWORK_STATE_CONNECTING_WIRED, "NETWORK_STATE_CONNECTING_WIRED", "connecting-wired"}, {NETWORK_STATE_CONNECTING_MOBILE, "NETWORK_STATE_CONNECTING_MOBILE", "connecting-mobile"}, {NETWORK_STATE_CONNECTING_VPN, "NETWORK_STATE_CONNECTING_VPN", "connecting-vpn"}, {NETWORK_STATE_FAILED_WIRED, "NETWORK_STATE_FAILED_WIRED", "failed-wired"}, {NETWORK_STATE_FAILED_WIFI, "NETWORK_STATE_FAILED_WIFI", "failed-wifi"}, {NETWORK_STATE_FAILED_MOBILE, "NETWORK_STATE_FAILED_MOBILE", "failed-mobile"}, {NETWORK_STATE_FAILED_VPN, "NETWORK_STATE_FAILED_VPN", "failed-vpn"}, {0, NULL, NULL}};
		GType network_state_type_id;
		network_state_type_id = g_enum_register_static ("NetworkState", values);
		g_once_init_leave (&network_state_type_id__volatile, network_state_type_id);
	}
	return network_state_type_id__volatile;
}


GType
network_utils_custom_mode_get_type (void)
{
	static volatile gsize network_utils_custom_mode_type_id__volatile = 0;
	if (g_once_init_enter (&network_utils_custom_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{NETWORK_UTILS_CUSTOM_MODE_PROXY_NONE, "NETWORK_UTILS_CUSTOM_MODE_PROXY_NONE", "proxy-none"}, {NETWORK_UTILS_CUSTOM_MODE_PROXY_MANUAL, "NETWORK_UTILS_CUSTOM_MODE_PROXY_MANUAL", "proxy-manual"}, {NETWORK_UTILS_CUSTOM_MODE_PROXY_AUTO, "NETWORK_UTILS_CUSTOM_MODE_PROXY_AUTO", "proxy-auto"}, {NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_ENABLED, "NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_ENABLED", "hotspot-enabled"}, {NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_DISABLED, "NETWORK_UTILS_CUSTOM_MODE_HOTSPOT_DISABLED", "hotspot-disabled"}, {NETWORK_UTILS_CUSTOM_MODE_INVALID, "NETWORK_UTILS_CUSTOM_MODE_INVALID", "invalid"}, {0, NULL, NULL}};
		GType network_utils_custom_mode_type_id;
		network_utils_custom_mode_type_id = g_enum_register_static ("NetworkUtilsCustomMode", values);
		g_once_init_leave (&network_utils_custom_mode_type_id__volatile, network_utils_custom_mode_type_id);
	}
	return network_utils_custom_mode_type_id__volatile;
}


GType
network_utils_item_type_get_type (void)
{
	static volatile gsize network_utils_item_type_type_id__volatile = 0;
	if (g_once_init_enter (&network_utils_item_type_type_id__volatile)) {
		static const GEnumValue values[] = {{NETWORK_UTILS_ITEM_TYPE_DEVICE, "NETWORK_UTILS_ITEM_TYPE_DEVICE", "device"}, {NETWORK_UTILS_ITEM_TYPE_VIRTUAL, "NETWORK_UTILS_ITEM_TYPE_VIRTUAL", "virtual"}, {NETWORK_UTILS_ITEM_TYPE_INVALID, "NETWORK_UTILS_ITEM_TYPE_INVALID", "invalid"}, {0, NULL, NULL}};
		GType network_utils_item_type_type_id;
		network_utils_item_type_type_id = g_enum_register_static ("NetworkUtilsItemType", values);
		g_once_init_leave (&network_utils_item_type_type_id__volatile, network_utils_item_type_type_id);
	}
	return network_utils_item_type_type_id__volatile;
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 77 "../src/Utils.vala"
	return self ? g_object_ref (self) : NULL;
#line 316 "Utils.c"
}


static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 77 "../src/Utils.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 77 "../src/Utils.vala"
	return _data1_;
#line 327 "Utils.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 77 "../src/Utils.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 77 "../src/Utils.vala"
		_g_object_unref0 (_data1_->connection);
#line 77 "../src/Utils.vala"
		g_slice_free (Block1Data, _data1_);
#line 342 "Utils.c"
	}
}


static void
__lambda4_ (Block1Data* _data1_,
            GObject* obj,
            GAsyncResult* res)
{
	GError * _inner_error_ = NULL;
#line 78 "../src/Utils.vala"
	g_return_if_fail (res != NULL);
#line 355 "Utils.c"
	{
		GVariant* secrets = NULL;
		GVariant* _tmp0_;
		GVariant* _tmp1_;
#line 80 "../src/Utils.vala"
		_tmp0_ = nm_remote_connection_get_secrets_finish (_data1_->connection, res, &_inner_error_);
#line 80 "../src/Utils.vala"
		secrets = _tmp0_;
#line 80 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 366 "Utils.c"
			goto __catch0_g_error;
		}
#line 81 "../src/Utils.vala"
		_tmp1_ = secrets;
#line 81 "../src/Utils.vala"
		nm_connection_update_secrets ((NMConnection*) _data1_->connection, NM_SETTING_WIRELESS_SECURITY_SETTING_NAME, _tmp1_, &_inner_error_);
#line 81 "../src/Utils.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 81 "../src/Utils.vala"
			_g_variant_unref0 (secrets);
#line 377 "Utils.c"
			goto __catch0_g_error;
		}
#line 79 "../src/Utils.vala"
		_g_variant_unref0 (secrets);
#line 382 "Utils.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 79 "../src/Utils.vala"
		e = _inner_error_;
#line 79 "../src/Utils.vala"
		_inner_error_ = NULL;
#line 83 "../src/Utils.vala"
		_tmp2_ = e;
#line 83 "../src/Utils.vala"
		_tmp3_ = _tmp2_->message;
#line 83 "../src/Utils.vala"
		g_warning ("Utils.vala:83: %s\n", _tmp3_);
#line 84 "../src/Utils.vala"
		_g_error_free0 (e);
#line 84 "../src/Utils.vala"
		return;
#line 404 "Utils.c"
	}
	__finally0:
#line 79 "../src/Utils.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 79 "../src/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 79 "../src/Utils.vala"
		g_clear_error (&_inner_error_);
#line 79 "../src/Utils.vala"
		return;
#line 415 "Utils.c"
	}
#line 87 "../src/Utils.vala"
	_data1_->callback (_data1_->callback_target);
#line 419 "Utils.c"
}


static void
___lambda4__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 78 "../src/Utils.vala"
	__lambda4_ (self, source_object, res);
#line 78 "../src/Utils.vala"
	block1_data_unref (self);
#line 432 "Utils.c"
}


void
network_utils_update_secrets (NMRemoteConnection* connection,
                              NetworkUtilsUpdateSecretCallback callback,
                              gpointer callback_target)
{
	Block1Data* _data1_;
	NMRemoteConnection* _tmp0_;
#line 77 "../src/Utils.vala"
	g_return_if_fail (connection != NULL);
#line 77 "../src/Utils.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 77 "../src/Utils.vala"
	_data1_->_ref_count_ = 1;
#line 77 "../src/Utils.vala"
	_tmp0_ = _g_object_ref0 (connection);
#line 77 "../src/Utils.vala"
	_g_object_unref0 (_data1_->connection);
#line 77 "../src/Utils.vala"
	_data1_->connection = _tmp0_;
#line 77 "../src/Utils.vala"
	_data1_->callback = callback;
#line 77 "../src/Utils.vala"
	_data1_->callback_target = callback_target;
#line 78 "../src/Utils.vala"
	nm_remote_connection_get_secrets_async (_data1_->connection, NM_SETTING_WIRELESS_SECURITY_SETTING_NAME, NULL, ___lambda4__gasync_ready_callback, block1_data_ref (_data1_));
#line 77 "../src/Utils.vala"
	block1_data_unref (_data1_);
#line 77 "../src/Utils.vala"
	_data1_ = NULL;
#line 465 "Utils.c"
}


gboolean
network_utils_get_device_is_hotspot (NMDeviceWifi* wifi_device)
{
	gboolean result = FALSE;
	NMActiveConnection* _tmp0_;
#line 91 "../src/Utils.vala"
	g_return_val_if_fail (wifi_device != NULL, FALSE);
#line 92 "../src/Utils.vala"
	_tmp0_ = nm_device_get_active_connection ((NMDevice*) wifi_device);
#line 92 "../src/Utils.vala"
	if (_tmp0_ != NULL) {
#line 480 "Utils.c"
		NMRemoteConnection* connection = NULL;
		NMActiveConnection* _tmp1_;
		NMRemoteConnection* _tmp2_;
		NMRemoteConnection* _tmp3_;
		NMRemoteConnection* _tmp4_;
#line 93 "../src/Utils.vala"
		_tmp1_ = nm_device_get_active_connection ((NMDevice*) wifi_device);
#line 93 "../src/Utils.vala"
		_tmp2_ = nm_active_connection_get_connection (_tmp1_);
#line 93 "../src/Utils.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 93 "../src/Utils.vala"
		connection = _tmp3_;
#line 94 "../src/Utils.vala"
		_tmp4_ = connection;
#line 94 "../src/Utils.vala"
		if (_tmp4_ != NULL) {
#line 498 "Utils.c"
			NMSettingIP4Config* ip4_setting = NULL;
			NMRemoteConnection* _tmp5_;
			NMSettingIP4Config* _tmp6_;
			NMSettingIP4Config* _tmp7_;
			gboolean _tmp8_ = FALSE;
			NMSettingIP4Config* _tmp9_;
#line 95 "../src/Utils.vala"
			_tmp5_ = connection;
#line 95 "../src/Utils.vala"
			_tmp6_ = nm_connection_get_setting_ip4_config ((NMConnection*) _tmp5_);
#line 95 "../src/Utils.vala"
			_tmp7_ = _g_object_ref0 (_tmp6_);
#line 95 "../src/Utils.vala"
			ip4_setting = _tmp7_;
#line 96 "../src/Utils.vala"
			_tmp9_ = ip4_setting;
#line 96 "../src/Utils.vala"
			if (_tmp9_ != NULL) {
#line 517 "Utils.c"
				NMSettingIP4Config* _tmp10_;
				const gchar* _tmp11_;
#line 96 "../src/Utils.vala"
				_tmp10_ = ip4_setting;
#line 96 "../src/Utils.vala"
				_tmp11_ = nm_setting_ip_config_get_method ((NMSettingIPConfig*) _tmp10_);
#line 96 "../src/Utils.vala"
				_tmp8_ = g_strcmp0 (_tmp11_, "shared") == 0;
#line 526 "Utils.c"
			} else {
#line 96 "../src/Utils.vala"
				_tmp8_ = FALSE;
#line 530 "Utils.c"
			}
#line 96 "../src/Utils.vala"
			result = _tmp8_;
#line 96 "../src/Utils.vala"
			_g_object_unref0 (ip4_setting);
#line 96 "../src/Utils.vala"
			_g_object_unref0 (connection);
#line 96 "../src/Utils.vala"
			return result;
#line 540 "Utils.c"
		}
#line 92 "../src/Utils.vala"
		_g_object_unref0 (connection);
#line 544 "Utils.c"
	}
#line 100 "../src/Utils.vala"
	result = FALSE;
#line 100 "../src/Utils.vala"
	return result;
#line 550 "Utils.c"
}


gboolean
network_utils_get_connection_is_hotspot (NMConnection* connection)
{
	gboolean result = FALSE;
	NMSettingConnection* setting_connection = NULL;
	NMSettingConnection* _tmp0_;
	NMSettingConnection* _tmp1_;
	NMSettingConnection* _tmp2_;
	const gchar* _tmp3_;
	NMSettingWireless* setting_wireless = NULL;
	NMSettingWireless* _tmp4_;
	NMSettingWireless* _tmp5_;
	gboolean _tmp6_ = FALSE;
	NMSettingWireless* _tmp7_;
	const gchar* _tmp8_;
	NMSettingWirelessSecurity* _tmp11_;
	NMSettingIP4Config* ip4_config = NULL;
	NMSettingIP4Config* _tmp12_;
	NMSettingIP4Config* _tmp13_;
	NMSettingIP4Config* _tmp14_;
	const gchar* _tmp15_;
#line 103 "../src/Utils.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 104 "../src/Utils.vala"
	_tmp0_ = nm_connection_get_setting_connection (connection);
#line 104 "../src/Utils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 104 "../src/Utils.vala"
	setting_connection = _tmp1_;
#line 105 "../src/Utils.vala"
	_tmp2_ = setting_connection;
#line 105 "../src/Utils.vala"
	_tmp3_ = nm_setting_connection_get_connection_type (_tmp2_);
#line 105 "../src/Utils.vala"
	if (g_strcmp0 (_tmp3_, "802-11-wireless") != 0) {
#line 106 "../src/Utils.vala"
		result = FALSE;
#line 106 "../src/Utils.vala"
		_g_object_unref0 (setting_connection);
#line 106 "../src/Utils.vala"
		return result;
#line 595 "Utils.c"
	}
#line 109 "../src/Utils.vala"
	_tmp4_ = nm_connection_get_setting_wireless (connection);
#line 109 "../src/Utils.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 109 "../src/Utils.vala"
	setting_wireless = _tmp5_;
#line 110 "../src/Utils.vala"
	_tmp7_ = setting_wireless;
#line 110 "../src/Utils.vala"
	_tmp8_ = nm_setting_wireless_get_mode (_tmp7_);
#line 110 "../src/Utils.vala"
	if (g_strcmp0 (_tmp8_, "adhoc") != 0) {
#line 609 "Utils.c"
		NMSettingWireless* _tmp9_;
		const gchar* _tmp10_;
#line 111 "../src/Utils.vala"
		_tmp9_ = setting_wireless;
#line 111 "../src/Utils.vala"
		_tmp10_ = nm_setting_wireless_get_mode (_tmp9_);
#line 111 "../src/Utils.vala"
		_tmp6_ = g_strcmp0 (_tmp10_, "ap") != 0;
#line 618 "Utils.c"
	} else {
#line 110 "../src/Utils.vala"
		_tmp6_ = FALSE;
#line 622 "Utils.c"
	}
#line 110 "../src/Utils.vala"
	if (_tmp6_) {
#line 112 "../src/Utils.vala"
		result = FALSE;
#line 112 "../src/Utils.vala"
		_g_object_unref0 (setting_wireless);
#line 112 "../src/Utils.vala"
		_g_object_unref0 (setting_connection);
#line 112 "../src/Utils.vala"
		return result;
#line 634 "Utils.c"
	}
#line 115 "../src/Utils.vala"
	_tmp11_ = nm_connection_get_setting_wireless_security (connection);
#line 115 "../src/Utils.vala"
	if (_tmp11_ == NULL) {
#line 116 "../src/Utils.vala"
		result = FALSE;
#line 116 "../src/Utils.vala"
		_g_object_unref0 (setting_wireless);
#line 116 "../src/Utils.vala"
		_g_object_unref0 (setting_connection);
#line 116 "../src/Utils.vala"
		return result;
#line 648 "Utils.c"
	}
#line 119 "../src/Utils.vala"
	_tmp12_ = nm_connection_get_setting_ip4_config (connection);
#line 119 "../src/Utils.vala"
	_tmp13_ = _g_object_ref0 (_tmp12_);
#line 119 "../src/Utils.vala"
	ip4_config = _tmp13_;
#line 120 "../src/Utils.vala"
	_tmp14_ = ip4_config;
#line 120 "../src/Utils.vala"
	_tmp15_ = nm_setting_ip_config_get_method ((NMSettingIPConfig*) _tmp14_);
#line 120 "../src/Utils.vala"
	if (g_strcmp0 (_tmp15_, "shared") != 0) {
#line 121 "../src/Utils.vala"
		result = FALSE;
#line 121 "../src/Utils.vala"
		_g_object_unref0 (ip4_config);
#line 121 "../src/Utils.vala"
		_g_object_unref0 (setting_wireless);
#line 121 "../src/Utils.vala"
		_g_object_unref0 (setting_connection);
#line 121 "../src/Utils.vala"
		return result;
#line 672 "Utils.c"
	}
#line 124 "../src/Utils.vala"
	result = TRUE;
#line 124 "../src/Utils.vala"
	_g_object_unref0 (ip4_config);
#line 124 "../src/Utils.vala"
	_g_object_unref0 (setting_wireless);
#line 124 "../src/Utils.vala"
	_g_object_unref0 (setting_connection);
#line 124 "../src/Utils.vala"
	return result;
#line 684 "Utils.c"
}


gchar*
network_utils_state_to_string (NMDeviceState state)
{
	gchar* result = NULL;
#line 143 "../src/Utils.vala"
	switch (state) {
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_ACTIVATED:
#line 696 "Utils.c"
		{
			gchar* _tmp0_;
#line 145 "../src/Utils.vala"
			_tmp0_ = g_strdup (_ ("Connected"));
#line 145 "../src/Utils.vala"
			result = _tmp0_;
#line 145 "../src/Utils.vala"
			return result;
#line 705 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_DISCONNECTED:
#line 709 "Utils.c"
		{
			gchar* _tmp1_;
#line 147 "../src/Utils.vala"
			_tmp1_ = g_strdup (_ ("Disconnected"));
#line 147 "../src/Utils.vala"
			result = _tmp1_;
#line 147 "../src/Utils.vala"
			return result;
#line 718 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_UNMANAGED:
#line 722 "Utils.c"
		{
			gchar* _tmp2_;
#line 149 "../src/Utils.vala"
			_tmp2_ = g_strdup (_ ("Unmanaged"));
#line 149 "../src/Utils.vala"
			result = _tmp2_;
#line 149 "../src/Utils.vala"
			return result;
#line 731 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_PREPARE:
#line 735 "Utils.c"
		{
			gchar* _tmp3_;
#line 151 "../src/Utils.vala"
			_tmp3_ = g_strdup (_ ("In preparation"));
#line 151 "../src/Utils.vala"
			result = _tmp3_;
#line 151 "../src/Utils.vala"
			return result;
#line 744 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_CONFIG:
#line 748 "Utils.c"
		{
			gchar* _tmp4_;
#line 153 "../src/Utils.vala"
			_tmp4_ = g_strdup (_ ("Connecting…"));
#line 153 "../src/Utils.vala"
			result = _tmp4_;
#line 153 "../src/Utils.vala"
			return result;
#line 757 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_NEED_AUTH:
#line 761 "Utils.c"
		{
			gchar* _tmp5_;
#line 155 "../src/Utils.vala"
			_tmp5_ = g_strdup (_ ("Requires more information"));
#line 155 "../src/Utils.vala"
			result = _tmp5_;
#line 155 "../src/Utils.vala"
			return result;
#line 770 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_IP_CONFIG:
#line 774 "Utils.c"
		{
			gchar* _tmp6_;
#line 157 "../src/Utils.vala"
			_tmp6_ = g_strdup (_ ("Requesting adresses…"));
#line 157 "../src/Utils.vala"
			result = _tmp6_;
#line 157 "../src/Utils.vala"
			return result;
#line 783 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_IP_CHECK:
#line 787 "Utils.c"
		{
			gchar* _tmp7_;
#line 159 "../src/Utils.vala"
			_tmp7_ = g_strdup (_ ("Checking connection…"));
#line 159 "../src/Utils.vala"
			result = _tmp7_;
#line 159 "../src/Utils.vala"
			return result;
#line 796 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_SECONDARIES:
#line 800 "Utils.c"
		{
			gchar* _tmp8_;
#line 161 "../src/Utils.vala"
			_tmp8_ = g_strdup (_ ("Waiting for connection…"));
#line 161 "../src/Utils.vala"
			result = _tmp8_;
#line 161 "../src/Utils.vala"
			return result;
#line 809 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_DEACTIVATING:
#line 813 "Utils.c"
		{
			gchar* _tmp9_;
#line 163 "../src/Utils.vala"
			_tmp9_ = g_strdup (_ ("Disconnecting…"));
#line 163 "../src/Utils.vala"
			result = _tmp9_;
#line 163 "../src/Utils.vala"
			return result;
#line 822 "Utils.c"
		}
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_FAILED:
#line 826 "Utils.c"
		{
			gchar* _tmp10_;
#line 165 "../src/Utils.vala"
			_tmp10_ = g_strdup (_ ("Failed to connect"));
#line 165 "../src/Utils.vala"
			result = _tmp10_;
#line 165 "../src/Utils.vala"
			return result;
#line 835 "Utils.c"
		}
		default:
#line 143 "../src/Utils.vala"
		case NM_DEVICE_STATE_UNKNOWN:
#line 840 "Utils.c"
		{
			gchar* _tmp11_;
#line 168 "../src/Utils.vala"
			_tmp11_ = g_strdup (NETWORK_UNKNOWN_STR);
#line 168 "../src/Utils.vala"
			result = _tmp11_;
#line 168 "../src/Utils.vala"
			return result;
#line 849 "Utils.c"
		}
	}
}


gchar*
network_utils_type_to_string (NMDeviceType type)
{
	gchar* result = NULL;
#line 173 "../src/Utils.vala"
	switch (type) {
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_ETHERNET:
#line 863 "Utils.c"
		{
			gchar* _tmp0_;
#line 175 "../src/Utils.vala"
			_tmp0_ = g_strdup (_ ("Ethernet"));
#line 175 "../src/Utils.vala"
			result = _tmp0_;
#line 175 "../src/Utils.vala"
			return result;
#line 872 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_WIFI:
#line 876 "Utils.c"
		{
			gchar* _tmp1_;
#line 177 "../src/Utils.vala"
			_tmp1_ = g_strdup (_ ("Wi-Fi"));
#line 177 "../src/Utils.vala"
			result = _tmp1_;
#line 177 "../src/Utils.vala"
			return result;
#line 885 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_UNUSED1:
#line 889 "Utils.c"
		{
			gchar* _tmp2_;
#line 179 "../src/Utils.vala"
			_tmp2_ = g_strdup (_ ("Not used"));
#line 179 "../src/Utils.vala"
			result = _tmp2_;
#line 179 "../src/Utils.vala"
			return result;
#line 898 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_UNUSED2:
#line 902 "Utils.c"
		{
			gchar* _tmp3_;
#line 181 "../src/Utils.vala"
			_tmp3_ = g_strdup (_ ("Not used"));
#line 181 "../src/Utils.vala"
			result = _tmp3_;
#line 181 "../src/Utils.vala"
			return result;
#line 911 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_BT:
#line 915 "Utils.c"
		{
			gchar* _tmp4_;
#line 183 "../src/Utils.vala"
			_tmp4_ = g_strdup (_ ("Bluetooth"));
#line 183 "../src/Utils.vala"
			result = _tmp4_;
#line 183 "../src/Utils.vala"
			return result;
#line 924 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_OLPC_MESH:
#line 928 "Utils.c"
		{
			gchar* _tmp5_;
#line 185 "../src/Utils.vala"
			_tmp5_ = g_strdup (_ ("OLPC XO"));
#line 185 "../src/Utils.vala"
			result = _tmp5_;
#line 185 "../src/Utils.vala"
			return result;
#line 937 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_WIMAX:
#line 941 "Utils.c"
		{
			gchar* _tmp6_;
#line 187 "../src/Utils.vala"
			_tmp6_ = g_strdup (_ ("WiMAX Broadband"));
#line 187 "../src/Utils.vala"
			result = _tmp6_;
#line 187 "../src/Utils.vala"
			return result;
#line 950 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_MODEM:
#line 954 "Utils.c"
		{
			gchar* _tmp7_;
#line 189 "../src/Utils.vala"
			_tmp7_ = g_strdup (_ ("Modem"));
#line 189 "../src/Utils.vala"
			result = _tmp7_;
#line 189 "../src/Utils.vala"
			return result;
#line 963 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_INFINIBAND:
#line 967 "Utils.c"
		{
			gchar* _tmp8_;
#line 191 "../src/Utils.vala"
			_tmp8_ = g_strdup (_ ("InfiniBand device"));
#line 191 "../src/Utils.vala"
			result = _tmp8_;
#line 191 "../src/Utils.vala"
			return result;
#line 976 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_BOND:
#line 980 "Utils.c"
		{
			gchar* _tmp9_;
#line 193 "../src/Utils.vala"
			_tmp9_ = g_strdup (_ ("Bond master"));
#line 193 "../src/Utils.vala"
			result = _tmp9_;
#line 193 "../src/Utils.vala"
			return result;
#line 989 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_VLAN:
#line 993 "Utils.c"
		{
			gchar* _tmp10_;
#line 195 "../src/Utils.vala"
			_tmp10_ = g_strdup (_ ("VLAN Interface"));
#line 195 "../src/Utils.vala"
			result = _tmp10_;
#line 195 "../src/Utils.vala"
			return result;
#line 1002 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_ADSL:
#line 1006 "Utils.c"
		{
			gchar* _tmp11_;
#line 197 "../src/Utils.vala"
			_tmp11_ = g_strdup (_ ("ADSL Modem"));
#line 197 "../src/Utils.vala"
			result = _tmp11_;
#line 197 "../src/Utils.vala"
			return result;
#line 1015 "Utils.c"
		}
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_BRIDGE:
#line 1019 "Utils.c"
		{
			gchar* _tmp12_;
#line 199 "../src/Utils.vala"
			_tmp12_ = g_strdup (_ ("Bridge master"));
#line 199 "../src/Utils.vala"
			result = _tmp12_;
#line 199 "../src/Utils.vala"
			return result;
#line 1028 "Utils.c"
		}
		default:
#line 173 "../src/Utils.vala"
		case NM_DEVICE_TYPE_UNKNOWN:
#line 1033 "Utils.c"
		{
			gchar* _tmp13_;
#line 202 "../src/Utils.vala"
			_tmp13_ = g_strdup (NETWORK_UNKNOWN_STR);
#line 202 "../src/Utils.vala"
			result = _tmp13_;
#line 202 "../src/Utils.vala"
			return result;
#line 1042 "Utils.c"
		}
	}
}


NetworkUtils*
network_utils_construct (GType object_type)
{
	NetworkUtils* self = NULL;
#line 74 "../src/Utils.vala"
	self = (NetworkUtils*) g_type_create_instance (object_type);
#line 74 "../src/Utils.vala"
	return self;
#line 1056 "Utils.c"
}


NetworkUtils*
network_utils_new (void)
{
#line 74 "../src/Utils.vala"
	return network_utils_construct (NETWORK_TYPE_UTILS);
#line 1065 "Utils.c"
}


static void
network_value_utils_init (GValue* value)
{
#line 74 "../src/Utils.vala"
	value->data[0].v_pointer = NULL;
#line 1074 "Utils.c"
}


static void
network_value_utils_free_value (GValue* value)
{
#line 74 "../src/Utils.vala"
	if (value->data[0].v_pointer) {
#line 74 "../src/Utils.vala"
		network_utils_unref (value->data[0].v_pointer);
#line 1085 "Utils.c"
	}
}


static void
network_value_utils_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 74 "../src/Utils.vala"
	if (src_value->data[0].v_pointer) {
#line 74 "../src/Utils.vala"
		dest_value->data[0].v_pointer = network_utils_ref (src_value->data[0].v_pointer);
#line 1098 "Utils.c"
	} else {
#line 74 "../src/Utils.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1102 "Utils.c"
	}
}


static gpointer
network_value_utils_peek_pointer (const GValue* value)
{
#line 74 "../src/Utils.vala"
	return value->data[0].v_pointer;
#line 1112 "Utils.c"
}


static gchar*
network_value_utils_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 74 "../src/Utils.vala"
	if (collect_values[0].v_pointer) {
#line 1124 "Utils.c"
		NetworkUtils * object;
		object = collect_values[0].v_pointer;
#line 74 "../src/Utils.vala"
		if (object->parent_instance.g_class == NULL) {
#line 74 "../src/Utils.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1131 "Utils.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 74 "../src/Utils.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1135 "Utils.c"
		}
#line 74 "../src/Utils.vala"
		value->data[0].v_pointer = network_utils_ref (object);
#line 1139 "Utils.c"
	} else {
#line 74 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 1143 "Utils.c"
	}
#line 74 "../src/Utils.vala"
	return NULL;
#line 1147 "Utils.c"
}


static gchar*
network_value_utils_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	NetworkUtils ** object_p;
	object_p = collect_values[0].v_pointer;
#line 74 "../src/Utils.vala"
	if (!object_p) {
#line 74 "../src/Utils.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1163 "Utils.c"
	}
#line 74 "../src/Utils.vala"
	if (!value->data[0].v_pointer) {
#line 74 "../src/Utils.vala"
		*object_p = NULL;
#line 1169 "Utils.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 74 "../src/Utils.vala"
		*object_p = value->data[0].v_pointer;
#line 1173 "Utils.c"
	} else {
#line 74 "../src/Utils.vala"
		*object_p = network_utils_ref (value->data[0].v_pointer);
#line 1177 "Utils.c"
	}
#line 74 "../src/Utils.vala"
	return NULL;
#line 1181 "Utils.c"
}


GParamSpec*
network_param_spec_utils (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	NetworkParamSpecUtils* spec;
#line 74 "../src/Utils.vala"
	g_return_val_if_fail (g_type_is_a (object_type, NETWORK_TYPE_UTILS), NULL);
#line 74 "../src/Utils.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 74 "../src/Utils.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 74 "../src/Utils.vala"
	return G_PARAM_SPEC (spec);
#line 1201 "Utils.c"
}


gpointer
network_value_get_utils (const GValue* value)
{
#line 74 "../src/Utils.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NETWORK_TYPE_UTILS), NULL);
#line 74 "../src/Utils.vala"
	return value->data[0].v_pointer;
#line 1212 "Utils.c"
}


void
network_value_set_utils (GValue* value,
                         gpointer v_object)
{
	NetworkUtils * old;
#line 74 "../src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NETWORK_TYPE_UTILS));
#line 74 "../src/Utils.vala"
	old = value->data[0].v_pointer;
#line 74 "../src/Utils.vala"
	if (v_object) {
#line 74 "../src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NETWORK_TYPE_UTILS));
#line 74 "../src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 74 "../src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 74 "../src/Utils.vala"
		network_utils_ref (value->data[0].v_pointer);
#line 1235 "Utils.c"
	} else {
#line 74 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 1239 "Utils.c"
	}
#line 74 "../src/Utils.vala"
	if (old) {
#line 74 "../src/Utils.vala"
		network_utils_unref (old);
#line 1245 "Utils.c"
	}
}


void
network_value_take_utils (GValue* value,
                          gpointer v_object)
{
	NetworkUtils * old;
#line 74 "../src/Utils.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, NETWORK_TYPE_UTILS));
#line 74 "../src/Utils.vala"
	old = value->data[0].v_pointer;
#line 74 "../src/Utils.vala"
	if (v_object) {
#line 74 "../src/Utils.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, NETWORK_TYPE_UTILS));
#line 74 "../src/Utils.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 74 "../src/Utils.vala"
		value->data[0].v_pointer = v_object;
#line 1267 "Utils.c"
	} else {
#line 74 "../src/Utils.vala"
		value->data[0].v_pointer = NULL;
#line 1271 "Utils.c"
	}
#line 74 "../src/Utils.vala"
	if (old) {
#line 74 "../src/Utils.vala"
		network_utils_unref (old);
#line 1277 "Utils.c"
	}
}


static void
network_utils_class_init (NetworkUtilsClass * klass)
{
#line 74 "../src/Utils.vala"
	network_utils_parent_class = g_type_class_peek_parent (klass);
#line 74 "../src/Utils.vala"
	((NetworkUtilsClass *) klass)->finalize = network_utils_finalize;
#line 1289 "Utils.c"
}


static void
network_utils_instance_init (NetworkUtils * self)
{
#line 74 "../src/Utils.vala"
	self->ref_count = 1;
#line 1298 "Utils.c"
}


static void
network_utils_finalize (NetworkUtils * obj)
{
	NetworkUtils * self;
#line 74 "../src/Utils.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_UTILS, NetworkUtils);
#line 74 "../src/Utils.vala"
	g_signal_handlers_destroy (self);
#line 1310 "Utils.c"
}


GType
network_utils_get_type (void)
{
	static volatile gsize network_utils_type_id__volatile = 0;
	if (g_once_init_enter (&network_utils_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { network_value_utils_init, network_value_utils_free_value, network_value_utils_copy_value, network_value_utils_peek_pointer, "p", network_value_utils_collect_value, "p", network_value_utils_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NetworkUtilsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_utils_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkUtils), 0, (GInstanceInitFunc) network_utils_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType network_utils_type_id;
		network_utils_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NetworkUtils", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&network_utils_type_id__volatile, network_utils_type_id);
	}
	return network_utils_type_id__volatile;
}


gpointer
network_utils_ref (gpointer instance)
{
	NetworkUtils * self;
	self = instance;
#line 74 "../src/Utils.vala"
	g_atomic_int_inc (&self->ref_count);
#line 74 "../src/Utils.vala"
	return instance;
#line 1339 "Utils.c"
}


void
network_utils_unref (gpointer instance)
{
	NetworkUtils * self;
	self = instance;
#line 74 "../src/Utils.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 74 "../src/Utils.vala"
		NETWORK_UTILS_GET_CLASS (self)->finalize (self);
#line 74 "../src/Utils.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1354 "Utils.c"
	}
}



