/* InfoBox.c generated by valac 0.42.5, the Vala compiler
 * generated from InfoBox.vala, do not modify */

/*-
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <NetworkManager.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <float.h>
#include <math.h>


#define NETWORK_WIDGETS_TYPE_INFO_BOX (network_widgets_info_box_get_type ())
#define NETWORK_WIDGETS_INFO_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox))
#define NETWORK_WIDGETS_INFO_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBoxClass))
#define NETWORK_WIDGETS_IS_INFO_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIDGETS_TYPE_INFO_BOX))
#define NETWORK_WIDGETS_IS_INFO_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIDGETS_TYPE_INFO_BOX))
#define NETWORK_WIDGETS_INFO_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBoxClass))

typedef struct _NetworkWidgetsInfoBox NetworkWidgetsInfoBox;
typedef struct _NetworkWidgetsInfoBoxClass NetworkWidgetsInfoBoxClass;
typedef struct _NetworkWidgetsInfoBoxPrivate NetworkWidgetsInfoBoxPrivate;

#define NETWORK_WIDGETS_TYPE_DEVICE_ITEM (network_widgets_device_item_get_type ())
#define NETWORK_WIDGETS_DEVICE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItem))
#define NETWORK_WIDGETS_DEVICE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItemClass))
#define NETWORK_WIDGETS_IS_DEVICE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM))
#define NETWORK_WIDGETS_IS_DEVICE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_WIDGETS_TYPE_DEVICE_ITEM))
#define NETWORK_WIDGETS_DEVICE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_WIDGETS_TYPE_DEVICE_ITEM, NetworkWidgetsDeviceItemClass))

typedef struct _NetworkWidgetsDeviceItem NetworkWidgetsDeviceItem;
typedef struct _NetworkWidgetsDeviceItemClass NetworkWidgetsDeviceItemClass;
enum  {
	NETWORK_WIDGETS_INFO_BOX_0_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY,
	NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES
};
static GParamSpec* network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL,
	NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS
};
static guint network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_NUM_SIGNALS] = {0};

struct _NetworkWidgetsInfoBox {
	GtkGrid parent_instance;
	NetworkWidgetsInfoBoxPrivate * priv;
};

struct _NetworkWidgetsInfoBoxClass {
	GtkGridClass parent_class;
};

struct _NetworkWidgetsInfoBoxPrivate {
	NMDevice* _device;
	NetworkWidgetsDeviceItem* _owner;
	GtkLabel* ip4address;
	GtkLabel* ip6address;
	GtkLabel* mask;
	GtkLabel* router;
	GtkLabel* sent;
	GtkLabel* received;
	GtkLabel* ip6address_head;
};

struct _Block8Data {
	int _ref_count_;
	NetworkWidgetsInfoBox* self;
	gint i;
	GPtrArray* addresses;
};


static gint NetworkWidgetsInfoBox_private_offset;
static gpointer network_widgets_info_box_parent_class = NULL;

GType network_widgets_info_box_get_type (void) G_GNUC_CONST;
GType network_widgets_device_item_get_type (void) G_GNUC_CONST;
NetworkWidgetsInfoBox* network_widgets_info_box_new_from_device (NMDevice* device);
NetworkWidgetsInfoBox* network_widgets_info_box_construct_from_device (GType object_type,
                                                                       NMDevice* device);
NetworkWidgetsInfoBox* network_widgets_info_box_new_from_owner (NetworkWidgetsDeviceItem* owner);
NetworkWidgetsInfoBox* network_widgets_info_box_construct_from_owner (GType object_type,
                                                                      NetworkWidgetsDeviceItem* owner);
NMDevice* network_widgets_device_item_get_item_device (NetworkWidgetsDeviceItem* self);
void network_widgets_info_box_update_activity (NetworkWidgetsInfoBox* self,
                                               const gchar* sent_bytes,
                                               const gchar* received_bytes);
#define NETWORK_UNKNOWN_STR _ ("Unknown")
void network_widgets_info_box_update_status (NetworkWidgetsInfoBox* self);
NMDevice* network_widgets_info_box_get_device (NetworkWidgetsInfoBox* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void ___lambda7_ (Block8Data* _data8_,
                  NMIPAddress* addr);
static void ____lambda7__gfunc (gconstpointer data,
                         gpointer self);
NetworkWidgetsDeviceItem* network_widgets_info_box_get_owner (NetworkWidgetsInfoBox* self);
NetworkWidgetsInfoBox* network_widgets_info_box_new (void);
NetworkWidgetsInfoBox* network_widgets_info_box_construct (GType object_type);
static void network_widgets_info_box_set_device (NetworkWidgetsInfoBox* self,
                                          NMDevice* value);
static void network_widgets_info_box_set_owner (NetworkWidgetsInfoBox* self,
                                         NetworkWidgetsDeviceItem* value);
static GObject * network_widgets_info_box_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static void _network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self);
static void __network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender,
                                                                    guint new_state,
                                                                    guint old_state,
                                                                    guint reason,
                                                                    gpointer self);
static void network_widgets_info_box_finalize (GObject * obj);
static void _vala_network_widgets_info_box_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_network_widgets_info_box_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);


static inline gpointer
network_widgets_info_box_get_instance_private (NetworkWidgetsInfoBox* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWidgetsInfoBox_private_offset);
}


NetworkWidgetsInfoBox*
network_widgets_info_box_construct_from_device (GType object_type,
                                                NMDevice* device)
{
	NetworkWidgetsInfoBox * self = NULL;
#line 36 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 37 "../src/Widgets/InfoBox.vala"
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "device", device, NULL);
#line 36 "../src/Widgets/InfoBox.vala"
	return self;
#line 175 "InfoBox.c"
}


NetworkWidgetsInfoBox*
network_widgets_info_box_new_from_device (NMDevice* device)
{
#line 36 "../src/Widgets/InfoBox.vala"
	return network_widgets_info_box_construct_from_device (NETWORK_WIDGETS_TYPE_INFO_BOX, device);
#line 184 "InfoBox.c"
}


NetworkWidgetsInfoBox*
network_widgets_info_box_construct_from_owner (GType object_type,
                                               NetworkWidgetsDeviceItem* owner)
{
	NetworkWidgetsInfoBox * self = NULL;
	NMDevice* _tmp0_;
	NMDevice* _tmp1_;
#line 40 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (owner != NULL, NULL);
#line 41 "../src/Widgets/InfoBox.vala"
	_tmp0_ = network_widgets_device_item_get_item_device (owner);
#line 41 "../src/Widgets/InfoBox.vala"
	_tmp1_ = _tmp0_;
#line 41 "../src/Widgets/InfoBox.vala"
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, "owner", owner, "device", _tmp1_, NULL);
#line 41 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (_tmp1_);
#line 40 "../src/Widgets/InfoBox.vala"
	return self;
#line 207 "InfoBox.c"
}


NetworkWidgetsInfoBox*
network_widgets_info_box_new_from_owner (NetworkWidgetsDeviceItem* owner)
{
#line 40 "../src/Widgets/InfoBox.vala"
	return network_widgets_info_box_construct_from_owner (NETWORK_WIDGETS_TYPE_INFO_BOX, owner);
#line 216 "InfoBox.c"
}


void
network_widgets_info_box_update_activity (NetworkWidgetsInfoBox* self,
                                          const gchar* sent_bytes,
                                          const gchar* received_bytes)
{
	const gchar* _tmp0_ = NULL;
	GtkLabel* _tmp1_;
	const gchar* _tmp2_ = NULL;
	GtkLabel* _tmp3_;
#line 126 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 126 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (sent_bytes != NULL);
#line 126 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (received_bytes != NULL);
#line 127 "../src/Widgets/InfoBox.vala"
	_tmp0_ = sent_bytes;
#line 127 "../src/Widgets/InfoBox.vala"
	if (_tmp0_ == NULL) {
#line 127 "../src/Widgets/InfoBox.vala"
		_tmp0_ = NETWORK_UNKNOWN_STR;
#line 241 "InfoBox.c"
	}
#line 127 "../src/Widgets/InfoBox.vala"
	_tmp1_ = self->priv->sent;
#line 127 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp1_, _tmp0_);
#line 128 "../src/Widgets/InfoBox.vala"
	_tmp2_ = received_bytes;
#line 128 "../src/Widgets/InfoBox.vala"
	if (_tmp2_ == NULL) {
#line 128 "../src/Widgets/InfoBox.vala"
		_tmp2_ = NETWORK_UNKNOWN_STR;
#line 253 "InfoBox.c"
	}
#line 128 "../src/Widgets/InfoBox.vala"
	_tmp3_ = self->priv->received;
#line 128 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp3_, _tmp2_);
#line 259 "InfoBox.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 132 "../src/Widgets/InfoBox.vala"
	return self ? g_object_ref (self) : NULL;
#line 268 "InfoBox.c"
}


static gint
g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	guint _tmp0_;
#line 5092 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 5092 "glib-2.0.vapi"
	_tmp0_ = self->len;
#line 5092 "glib-2.0.vapi"
	result = (gint) _tmp0_;
#line 5092 "glib-2.0.vapi"
	return result;
#line 285 "InfoBox.c"
}


static void
g_ptr_array_set_length (GPtrArray* self,
                        gint value)
{
#line 5093 "glib-2.0.vapi"
	g_return_if_fail (self != NULL);
#line 5093 "glib-2.0.vapi"
	g_ptr_array_set_size (self, value);
#line 297 "InfoBox.c"
}


static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 152 "../src/Widgets/InfoBox.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 152 "../src/Widgets/InfoBox.vala"
	return _data8_;
#line 308 "InfoBox.c"
}


static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 152 "../src/Widgets/InfoBox.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 319 "InfoBox.c"
		NetworkWidgetsInfoBox* self;
#line 152 "../src/Widgets/InfoBox.vala"
		self = _data8_->self;
#line 152 "../src/Widgets/InfoBox.vala"
		_g_ptr_array_unref0 (_data8_->addresses);
#line 152 "../src/Widgets/InfoBox.vala"
		_g_object_unref0 (self);
#line 152 "../src/Widgets/InfoBox.vala"
		g_slice_free (Block8Data, _data8_);
#line 329 "InfoBox.c"
	}
}


static gpointer
_g_ptr_array_ref0 (gpointer self)
{
#line 154 "../src/Widgets/InfoBox.vala"
	return self ? g_ptr_array_ref (self) : NULL;
#line 339 "InfoBox.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 364 "InfoBox.c"
}


static void
___lambda7_ (Block8Data* _data8_,
             NMIPAddress* addr)
{
	NetworkWidgetsInfoBox* self;
	gchar* inet_str = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	const gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gint _tmp19_;
	GPtrArray* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp29_;
#line 155 "../src/Widgets/InfoBox.vala"
	self = _data8_->self;
#line 155 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (addr != NULL);
#line 156 "../src/Widgets/InfoBox.vala"
	nm_ip_address_ref (addr);
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp0_ = nm_ip_address_get_address (addr);
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/", NULL);
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp2_ = _tmp1_;
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp3_ = g_strdup_printf ("%u", nm_ip_address_get_prefix (addr));
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp4_ = _tmp3_;
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp5_ = g_strconcat (_tmp2_, _tmp4_, NULL);
#line 157 "../src/Widgets/InfoBox.vala"
	_tmp6_ = _tmp5_;
#line 157 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp4_);
#line 157 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp2_);
#line 157 "../src/Widgets/InfoBox.vala"
	inet_str = _tmp6_;
#line 158 "../src/Widgets/InfoBox.vala"
	_tmp7_ = self->priv->ip6address;
#line 158 "../src/Widgets/InfoBox.vala"
	_tmp8_ = self->priv->ip6address_head;
#line 158 "../src/Widgets/InfoBox.vala"
	_tmp9_ = inet_str;
#line 158 "../src/Widgets/InfoBox.vala"
	_tmp10_ = string_strip (_tmp9_);
#line 158 "../src/Widgets/InfoBox.vala"
	_tmp11_ = _tmp10_;
#line 158 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, g_strcmp0 (_tmp11_, "") != 0);
#line 158 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp7_, g_strcmp0 (_tmp11_, "") != 0);
#line 158 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp11_);
#line 159 "../src/Widgets/InfoBox.vala"
	_tmp12_ = self->priv->ip6address;
#line 159 "../src/Widgets/InfoBox.vala"
	_tmp13_ = self->priv->ip6address;
#line 159 "../src/Widgets/InfoBox.vala"
	_tmp14_ = gtk_label_get_label (_tmp13_);
#line 159 "../src/Widgets/InfoBox.vala"
	_tmp15_ = _tmp14_;
#line 159 "../src/Widgets/InfoBox.vala"
	_tmp16_ = inet_str;
#line 159 "../src/Widgets/InfoBox.vala"
	_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 159 "../src/Widgets/InfoBox.vala"
	_tmp18_ = _tmp17_;
#line 159 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp13_, _tmp18_);
#line 159 "../src/Widgets/InfoBox.vala"
	_g_free0 (_tmp18_);
#line 160 "../src/Widgets/InfoBox.vala"
	_tmp19_ = _data8_->i;
#line 160 "../src/Widgets/InfoBox.vala"
	_tmp20_ = _data8_->addresses;
#line 160 "../src/Widgets/InfoBox.vala"
	_tmp21_ = g_ptr_array_get_length (_tmp20_);
#line 160 "../src/Widgets/InfoBox.vala"
	_tmp22_ = _tmp21_;
#line 160 "../src/Widgets/InfoBox.vala"
	if (_tmp19_ < _tmp22_) {
#line 468 "InfoBox.c"
		GtkLabel* _tmp23_;
		GtkLabel* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
#line 161 "../src/Widgets/InfoBox.vala"
		_tmp23_ = self->priv->ip6address;
#line 161 "../src/Widgets/InfoBox.vala"
		_tmp24_ = self->priv->ip6address;
#line 161 "../src/Widgets/InfoBox.vala"
		_tmp25_ = gtk_label_get_label (_tmp24_);
#line 161 "../src/Widgets/InfoBox.vala"
		_tmp26_ = _tmp25_;
#line 161 "../src/Widgets/InfoBox.vala"
		_tmp27_ = g_strconcat (_tmp26_, "\n", NULL);
#line 161 "../src/Widgets/InfoBox.vala"
		_tmp28_ = _tmp27_;
#line 161 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp24_, _tmp28_);
#line 161 "../src/Widgets/InfoBox.vala"
		_g_free0 (_tmp28_);
#line 491 "InfoBox.c"
	}
#line 164 "../src/Widgets/InfoBox.vala"
	_tmp29_ = _data8_->i;
#line 164 "../src/Widgets/InfoBox.vala"
	_data8_->i = _tmp29_ + 1;
#line 155 "../src/Widgets/InfoBox.vala"
	_g_free0 (inet_str);
#line 499 "InfoBox.c"
}


static void
____lambda7__gfunc (gconstpointer data,
                    gpointer self)
{
#line 155 "../src/Widgets/InfoBox.vala"
	___lambda7_ (self, (NMIPAddress*) data);
#line 509 "InfoBox.c"
}


void
network_widgets_info_box_update_status (NetworkWidgetsInfoBox* self)
{
	NMIPConfig* ipv4 = NULL;
	NMDevice* _tmp0_;
	NMIPConfig* _tmp1_;
	NMIPConfig* _tmp2_;
	NMIPConfig* _tmp3_;
	NMIPConfig* ip6 = NULL;
	NMDevice* _tmp28_;
	NMIPConfig* _tmp29_;
	NMIPConfig* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	NMIPConfig* _tmp33_;
	GtkLabel* _tmp34_;
	NMIPConfig* _tmp35_;
	NetworkWidgetsDeviceItem* _tmp40_;
#line 131 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/Widgets/InfoBox.vala"
	_tmp0_ = self->priv->_device;
#line 132 "../src/Widgets/InfoBox.vala"
	_tmp1_ = nm_device_get_ip4_config (_tmp0_);
#line 132 "../src/Widgets/InfoBox.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 132 "../src/Widgets/InfoBox.vala"
	ipv4 = _tmp2_;
#line 133 "../src/Widgets/InfoBox.vala"
	_tmp3_ = ipv4;
#line 133 "../src/Widgets/InfoBox.vala"
	if (_tmp3_ != NULL) {
#line 545 "InfoBox.c"
		NMIPConfig* _tmp4_;
		GPtrArray* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		const gchar* _tmp21_ = NULL;
		NMIPConfig* _tmp22_;
		const gchar* _tmp23_;
		GtkLabel* _tmp24_;
#line 134 "../src/Widgets/InfoBox.vala"
		_tmp4_ = ipv4;
#line 134 "../src/Widgets/InfoBox.vala"
		_tmp5_ = nm_ip_config_get_addresses (_tmp4_);
#line 134 "../src/Widgets/InfoBox.vala"
		_tmp6_ = g_ptr_array_get_length (_tmp5_);
#line 134 "../src/Widgets/InfoBox.vala"
		_tmp7_ = _tmp6_;
#line 134 "../src/Widgets/InfoBox.vala"
		if (_tmp7_ > 0) {
#line 564 "InfoBox.c"
			NMIPAddress* address = NULL;
			NMIPConfig* _tmp8_;
			GPtrArray* _tmp9_;
			gconstpointer _tmp10_;
			GtkLabel* _tmp11_;
			NMIPAddress* _tmp12_;
			const gchar* _tmp13_;
			guint32 mask_addr = 0U;
			NMIPAddress* _tmp14_;
			struct in_addr source_addr = {0};
			guint32 _tmp15_;
			struct in_addr _tmp16_ = {0};
			const gchar* _tmp17_ = NULL;
			struct in_addr _tmp18_;
			const gchar* _tmp19_;
			GtkLabel* _tmp20_;
#line 135 "../src/Widgets/InfoBox.vala"
			_tmp8_ = ipv4;
#line 135 "../src/Widgets/InfoBox.vala"
			_tmp9_ = nm_ip_config_get_addresses (_tmp8_);
#line 135 "../src/Widgets/InfoBox.vala"
			_tmp10_ = g_ptr_array_index (_tmp9_, (guint) 0);
#line 135 "../src/Widgets/InfoBox.vala"
			address = (NMIPAddress*) _tmp10_;
#line 136 "../src/Widgets/InfoBox.vala"
			_tmp11_ = self->priv->ip4address;
#line 136 "../src/Widgets/InfoBox.vala"
			_tmp12_ = address;
#line 136 "../src/Widgets/InfoBox.vala"
			_tmp13_ = nm_ip_address_get_address (_tmp12_);
#line 136 "../src/Widgets/InfoBox.vala"
			gtk_label_set_label (_tmp11_, _tmp13_);
#line 137 "../src/Widgets/InfoBox.vala"
			_tmp14_ = address;
#line 137 "../src/Widgets/InfoBox.vala"
			mask_addr = ~(((guint32) 0xffffffffLL) << nm_ip_address_get_prefix (_tmp14_));
#line 138 "../src/Widgets/InfoBox.vala"
			_tmp15_ = mask_addr;
#line 138 "../src/Widgets/InfoBox.vala"
			memset (&_tmp16_, 0, sizeof (struct in_addr));
#line 138 "../src/Widgets/InfoBox.vala"
			_tmp16_.s_addr = _tmp15_;
#line 138 "../src/Widgets/InfoBox.vala"
			source_addr = _tmp16_;
#line 139 "../src/Widgets/InfoBox.vala"
			_tmp18_ = source_addr;
#line 139 "../src/Widgets/InfoBox.vala"
			_tmp19_ = inet_ntoa (_tmp18_);
#line 139 "../src/Widgets/InfoBox.vala"
			_tmp17_ = _tmp19_;
#line 139 "../src/Widgets/InfoBox.vala"
			if (_tmp17_ == NULL) {
#line 139 "../src/Widgets/InfoBox.vala"
				_tmp17_ = NETWORK_UNKNOWN_STR;
#line 619 "InfoBox.c"
			}
#line 139 "../src/Widgets/InfoBox.vala"
			_tmp20_ = self->priv->mask;
#line 139 "../src/Widgets/InfoBox.vala"
			gtk_label_set_label (_tmp20_, _tmp17_);
#line 134 "../src/Widgets/InfoBox.vala"
			 (source_addr);
#line 627 "InfoBox.c"
		}
#line 142 "../src/Widgets/InfoBox.vala"
		_tmp22_ = ipv4;
#line 142 "../src/Widgets/InfoBox.vala"
		_tmp23_ = nm_ip_config_get_gateway (_tmp22_);
#line 142 "../src/Widgets/InfoBox.vala"
		_tmp21_ = _tmp23_;
#line 142 "../src/Widgets/InfoBox.vala"
		if (_tmp21_ == NULL) {
#line 142 "../src/Widgets/InfoBox.vala"
			_tmp21_ = NETWORK_UNKNOWN_STR;
#line 639 "InfoBox.c"
		}
#line 142 "../src/Widgets/InfoBox.vala"
		_tmp24_ = self->priv->router;
#line 142 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp24_, _tmp21_);
#line 645 "InfoBox.c"
	} else {
		GtkLabel* _tmp25_;
		GtkLabel* _tmp26_;
		GtkLabel* _tmp27_;
#line 144 "../src/Widgets/InfoBox.vala"
		_tmp25_ = self->priv->ip4address;
#line 144 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp25_, NETWORK_UNKNOWN_STR);
#line 145 "../src/Widgets/InfoBox.vala"
		_tmp26_ = self->priv->mask;
#line 145 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp26_, NETWORK_UNKNOWN_STR);
#line 146 "../src/Widgets/InfoBox.vala"
		_tmp27_ = self->priv->router;
#line 146 "../src/Widgets/InfoBox.vala"
		gtk_label_set_label (_tmp27_, NETWORK_UNKNOWN_STR);
#line 662 "InfoBox.c"
	}
#line 149 "../src/Widgets/InfoBox.vala"
	_tmp28_ = self->priv->_device;
#line 149 "../src/Widgets/InfoBox.vala"
	_tmp29_ = nm_device_get_ip6_config (_tmp28_);
#line 149 "../src/Widgets/InfoBox.vala"
	_tmp30_ = _g_object_ref0 (_tmp29_);
#line 149 "../src/Widgets/InfoBox.vala"
	ip6 = _tmp30_;
#line 150 "../src/Widgets/InfoBox.vala"
	_tmp31_ = self->priv->ip6address;
#line 150 "../src/Widgets/InfoBox.vala"
	_tmp32_ = self->priv->ip6address_head;
#line 150 "../src/Widgets/InfoBox.vala"
	_tmp33_ = ip6;
#line 150 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp32_, _tmp33_ != NULL);
#line 150 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp31_, _tmp33_ != NULL);
#line 151 "../src/Widgets/InfoBox.vala"
	_tmp34_ = self->priv->ip6address;
#line 151 "../src/Widgets/InfoBox.vala"
	gtk_label_set_label (_tmp34_, "");
#line 152 "../src/Widgets/InfoBox.vala"
	_tmp35_ = ip6;
#line 152 "../src/Widgets/InfoBox.vala"
	if (_tmp35_ != NULL) {
#line 690 "InfoBox.c"
		Block8Data* _data8_;
		NMIPConfig* _tmp36_;
		GPtrArray* _tmp37_;
		GPtrArray* _tmp38_;
		GPtrArray* _tmp39_;
#line 152 "../src/Widgets/InfoBox.vala"
		_data8_ = g_slice_new0 (Block8Data);
#line 152 "../src/Widgets/InfoBox.vala"
		_data8_->_ref_count_ = 1;
#line 152 "../src/Widgets/InfoBox.vala"
		_data8_->self = g_object_ref (self);
#line 153 "../src/Widgets/InfoBox.vala"
		_data8_->i = 1;
#line 154 "../src/Widgets/InfoBox.vala"
		_tmp36_ = ip6;
#line 154 "../src/Widgets/InfoBox.vala"
		_tmp37_ = nm_ip_config_get_addresses (_tmp36_);
#line 154 "../src/Widgets/InfoBox.vala"
		_tmp38_ = _g_ptr_array_ref0 (_tmp37_);
#line 154 "../src/Widgets/InfoBox.vala"
		_data8_->addresses = _tmp38_;
#line 155 "../src/Widgets/InfoBox.vala"
		_tmp39_ = _data8_->addresses;
#line 155 "../src/Widgets/InfoBox.vala"
		g_ptr_array_foreach (_tmp39_, ____lambda7__gfunc, _data8_);
#line 152 "../src/Widgets/InfoBox.vala"
		block8_data_unref (_data8_);
#line 152 "../src/Widgets/InfoBox.vala"
		_data8_ = NULL;
#line 720 "InfoBox.c"
	}
#line 169 "../src/Widgets/InfoBox.vala"
	_tmp40_ = self->priv->_owner;
#line 169 "../src/Widgets/InfoBox.vala"
	if (_tmp40_ != NULL) {
#line 726 "InfoBox.c"
		NetworkWidgetsDeviceItem* _tmp41_;
#line 170 "../src/Widgets/InfoBox.vala"
		_tmp41_ = self->priv->_owner;
#line 170 "../src/Widgets/InfoBox.vala"
		g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL], 0, _tmp41_);
#line 732 "InfoBox.c"
	}
#line 173 "../src/Widgets/InfoBox.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 131 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (ip6);
#line 131 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (ipv4);
#line 740 "InfoBox.c"
}


NetworkWidgetsInfoBox*
network_widgets_info_box_construct (GType object_type)
{
	NetworkWidgetsInfoBox * self = NULL;
#line 21 "../src/Widgets/InfoBox.vala"
	self = (NetworkWidgetsInfoBox*) g_object_new (object_type, NULL);
#line 21 "../src/Widgets/InfoBox.vala"
	return self;
#line 752 "InfoBox.c"
}


NetworkWidgetsInfoBox*
network_widgets_info_box_new (void)
{
#line 21 "../src/Widgets/InfoBox.vala"
	return network_widgets_info_box_construct (NETWORK_WIDGETS_TYPE_INFO_BOX);
#line 761 "InfoBox.c"
}


NMDevice*
network_widgets_info_box_get_device (NetworkWidgetsInfoBox* self)
{
	NMDevice* result;
	NMDevice* _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/Widgets/InfoBox.vala"
	_tmp0_ = self->priv->_device;
#line 24 "../src/Widgets/InfoBox.vala"
	result = _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
	return result;
#line 778 "InfoBox.c"
}


static void
network_widgets_info_box_set_device (NetworkWidgetsInfoBox* self,
                                     NMDevice* value)
{
#line 24 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/Widgets/InfoBox.vala"
	if (network_widgets_info_box_get_device (self) != value) {
#line 790 "InfoBox.c"
		NMDevice* _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/Widgets/InfoBox.vala"
		_g_object_unref0 (self->priv->_device);
#line 24 "../src/Widgets/InfoBox.vala"
		self->priv->_device = _tmp0_;
#line 24 "../src/Widgets/InfoBox.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY]);
#line 800 "InfoBox.c"
	}
}


NetworkWidgetsDeviceItem*
network_widgets_info_box_get_owner (NetworkWidgetsInfoBox* self)
{
	NetworkWidgetsDeviceItem* result;
	NetworkWidgetsDeviceItem* _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/Widgets/InfoBox.vala"
	_tmp0_ = self->priv->_owner;
#line 25 "../src/Widgets/InfoBox.vala"
	result = _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
	return result;
#line 818 "InfoBox.c"
}


static void
network_widgets_info_box_set_owner (NetworkWidgetsInfoBox* self,
                                    NetworkWidgetsDeviceItem* value)
{
#line 25 "../src/Widgets/InfoBox.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/Widgets/InfoBox.vala"
	if (network_widgets_info_box_get_owner (self) != value) {
#line 830 "InfoBox.c"
		NetworkWidgetsDeviceItem* _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/Widgets/InfoBox.vala"
		_g_object_unref0 (self->priv->_owner);
#line 25 "../src/Widgets/InfoBox.vala"
		self->priv->_owner = _tmp0_;
#line 25 "../src/Widgets/InfoBox.vala"
		g_object_notify_by_pspec ((GObject *) self, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY]);
#line 840 "InfoBox.c"
	}
}


static void
_network_widgets_info_box___lambda8_ (NetworkWidgetsInfoBox* self)
{
#line 118 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_update_status (self);
#line 119 "../src/Widgets/InfoBox.vala"
	g_signal_emit (self, network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL], 0);
#line 852 "InfoBox.c"
}


static void
__network_widgets_info_box___lambda8__nm_device_state_changed (NMDevice* _sender,
                                                               guint new_state,
                                                               guint old_state,
                                                               guint reason,
                                                               gpointer self)
{
#line 117 "../src/Widgets/InfoBox.vala"
	_network_widgets_info_box___lambda8_ ((NetworkWidgetsInfoBox*) self);
#line 865 "InfoBox.c"
}


static GObject *
network_widgets_info_box_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NetworkWidgetsInfoBox * self;
	GtkImage* sent_head = NULL;
	GtkImage* _tmp0_;
	GtkLabel* _tmp1_;
	GtkGrid* sent_grid = NULL;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	GtkGrid* _tmp4_;
	GtkGrid* _tmp5_;
	GtkImage* _tmp6_;
	GtkGrid* _tmp7_;
	GtkLabel* _tmp8_;
	GtkImage* received_head = NULL;
	GtkImage* _tmp9_;
	GtkLabel* _tmp10_;
	GtkGrid* received_grid = NULL;
	GtkGrid* _tmp11_;
	GtkGrid* _tmp12_;
	GtkGrid* _tmp13_;
	GtkGrid* _tmp14_;
	GtkImage* _tmp15_;
	GtkGrid* _tmp16_;
	GtkLabel* _tmp17_;
	GtkGrid* send_receive_grid = NULL;
	GtkGrid* _tmp18_;
	GtkGrid* _tmp19_;
	GtkGrid* _tmp20_;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkGrid* _tmp25_;
	GtkLabel* ip4address_head = NULL;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkLabel* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* mask_head = NULL;
	GtkLabel* _tmp38_;
	GtkLabel* _tmp39_;
	GtkLabel* _tmp40_;
	GtkLabel* _tmp41_;
	GtkLabel* _tmp42_;
	GtkLabel* router_head = NULL;
	GtkLabel* _tmp43_;
	GtkLabel* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkLabel* _tmp47_;
	GtkLabel* _tmp48_;
	GtkLabel* _tmp49_;
	GtkLabel* _tmp50_;
	GtkLabel* _tmp51_;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkLabel* _tmp55_;
	GtkLabel* _tmp56_;
	GtkLabel* _tmp57_;
	GtkLabel* _tmp58_;
	GtkLabel* _tmp59_;
	GtkLabel* _tmp60_;
	GtkLabel* _tmp61_;
	GtkLabel* _tmp62_;
	GtkGrid* _tmp63_;
	GtkLabel* _tmp64_;
	NMDevice* _tmp65_;
#line 44 "../src/Widgets/InfoBox.vala"
	parent_class = G_OBJECT_CLASS (network_widgets_info_box_parent_class);
#line 44 "../src/Widgets/InfoBox.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 44 "../src/Widgets/InfoBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 45 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 12);
#line 46 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_row_spacing ((GtkGrid*) self, 6);
#line 48 "../src/Widgets/InfoBox.vala"
	_tmp0_ = (GtkImage*) gtk_image_new_from_icon_name ("go-up-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 48 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp0_);
#line 48 "../src/Widgets/InfoBox.vala"
	sent_head = _tmp0_;
#line 49 "../src/Widgets/InfoBox.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 49 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp1_);
#line 49 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->sent);
#line 49 "../src/Widgets/InfoBox.vala"
	self->priv->sent = _tmp1_;
#line 51 "../src/Widgets/InfoBox.vala"
	_tmp2_ = (GtkGrid*) gtk_grid_new ();
#line 51 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp2_);
#line 51 "../src/Widgets/InfoBox.vala"
	sent_grid = _tmp2_;
#line 52 "../src/Widgets/InfoBox.vala"
	_tmp3_ = sent_grid;
#line 52 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing (_tmp3_, 12);
#line 53 "../src/Widgets/InfoBox.vala"
	_tmp4_ = sent_grid;
#line 53 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp4_, _ ("Sent"));
#line 54 "../src/Widgets/InfoBox.vala"
	_tmp5_ = sent_grid;
#line 54 "../src/Widgets/InfoBox.vala"
	_tmp6_ = sent_head;
#line 54 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 55 "../src/Widgets/InfoBox.vala"
	_tmp7_ = sent_grid;
#line 55 "../src/Widgets/InfoBox.vala"
	_tmp8_ = self->priv->sent;
#line 55 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 57 "../src/Widgets/InfoBox.vala"
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("go-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 57 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp9_);
#line 57 "../src/Widgets/InfoBox.vala"
	received_head = _tmp9_;
#line 58 "../src/Widgets/InfoBox.vala"
	_tmp10_ = (GtkLabel*) gtk_label_new (NULL);
#line 58 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp10_);
#line 58 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->received);
#line 58 "../src/Widgets/InfoBox.vala"
	self->priv->received = _tmp10_;
#line 60 "../src/Widgets/InfoBox.vala"
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
#line 60 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp11_);
#line 60 "../src/Widgets/InfoBox.vala"
	received_grid = _tmp11_;
#line 61 "../src/Widgets/InfoBox.vala"
	_tmp12_ = received_grid;
#line 61 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing (_tmp12_, 12);
#line 62 "../src/Widgets/InfoBox.vala"
	_tmp13_ = received_grid;
#line 62 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp13_, _ ("Received"));
#line 63 "../src/Widgets/InfoBox.vala"
	_tmp14_ = received_grid;
#line 63 "../src/Widgets/InfoBox.vala"
	_tmp15_ = received_head;
#line 63 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 64 "../src/Widgets/InfoBox.vala"
	_tmp16_ = received_grid;
#line 64 "../src/Widgets/InfoBox.vala"
	_tmp17_ = self->priv->received;
#line 64 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp16_, (GtkWidget*) _tmp17_);
#line 66 "../src/Widgets/InfoBox.vala"
	_tmp18_ = (GtkGrid*) gtk_grid_new ();
#line 66 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp18_);
#line 66 "../src/Widgets/InfoBox.vala"
	send_receive_grid = _tmp18_;
#line 67 "../src/Widgets/InfoBox.vala"
	_tmp19_ = send_receive_grid;
#line 67 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp19_, GTK_ALIGN_CENTER);
#line 68 "../src/Widgets/InfoBox.vala"
	_tmp20_ = send_receive_grid;
#line 68 "../src/Widgets/InfoBox.vala"
	gtk_grid_set_column_spacing (_tmp20_, 12);
#line 69 "../src/Widgets/InfoBox.vala"
	_tmp21_ = send_receive_grid;
#line 69 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp21_, 12);
#line 70 "../src/Widgets/InfoBox.vala"
	_tmp22_ = send_receive_grid;
#line 70 "../src/Widgets/InfoBox.vala"
	_tmp23_ = sent_grid;
#line 70 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 71 "../src/Widgets/InfoBox.vala"
	_tmp24_ = send_receive_grid;
#line 71 "../src/Widgets/InfoBox.vala"
	_tmp25_ = received_grid;
#line 71 "../src/Widgets/InfoBox.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 73 "../src/Widgets/InfoBox.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new (_ ("IP Address:"));
#line 73 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp26_);
#line 73 "../src/Widgets/InfoBox.vala"
	ip4address_head = _tmp26_;
#line 74 "../src/Widgets/InfoBox.vala"
	_tmp27_ = ip4address_head;
#line 74 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_END);
#line 76 "../src/Widgets/InfoBox.vala"
	_tmp28_ = (GtkLabel*) gtk_label_new (NULL);
#line 76 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp28_);
#line 76 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip4address);
#line 76 "../src/Widgets/InfoBox.vala"
	self->priv->ip4address = _tmp28_;
#line 77 "../src/Widgets/InfoBox.vala"
	_tmp29_ = self->priv->ip4address;
#line 77 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp29_, TRUE);
#line 78 "../src/Widgets/InfoBox.vala"
	_tmp30_ = self->priv->ip4address;
#line 78 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp30_, (gfloat) 0);
#line 80 "../src/Widgets/InfoBox.vala"
	_tmp31_ = (GtkLabel*) gtk_label_new (_ ("IPv6 Address:"));
#line 80 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp31_);
#line 80 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address_head);
#line 80 "../src/Widgets/InfoBox.vala"
	self->priv->ip6address_head = _tmp31_;
#line 81 "../src/Widgets/InfoBox.vala"
	_tmp32_ = self->priv->ip6address_head;
#line 81 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp32_, TRUE);
#line 82 "../src/Widgets/InfoBox.vala"
	_tmp33_ = self->priv->ip6address_head;
#line 82 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp33_, GTK_ALIGN_END);
#line 84 "../src/Widgets/InfoBox.vala"
	_tmp34_ = (GtkLabel*) gtk_label_new (NULL);
#line 84 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp34_);
#line 84 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address);
#line 84 "../src/Widgets/InfoBox.vala"
	self->priv->ip6address = _tmp34_;
#line 85 "../src/Widgets/InfoBox.vala"
	_tmp35_ = self->priv->ip6address;
#line 85 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp35_, TRUE);
#line 86 "../src/Widgets/InfoBox.vala"
	_tmp36_ = self->priv->ip6address;
#line 86 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp36_, TRUE);
#line 87 "../src/Widgets/InfoBox.vala"
	_tmp37_ = self->priv->ip6address;
#line 87 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp37_, (gfloat) 0);
#line 89 "../src/Widgets/InfoBox.vala"
	_tmp38_ = (GtkLabel*) gtk_label_new (_ ("Subnet mask:"));
#line 89 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp38_);
#line 89 "../src/Widgets/InfoBox.vala"
	mask_head = _tmp38_;
#line 90 "../src/Widgets/InfoBox.vala"
	_tmp39_ = mask_head;
#line 90 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp39_, GTK_ALIGN_END);
#line 92 "../src/Widgets/InfoBox.vala"
	_tmp40_ = (GtkLabel*) gtk_label_new (NULL);
#line 92 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp40_);
#line 92 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->mask);
#line 92 "../src/Widgets/InfoBox.vala"
	self->priv->mask = _tmp40_;
#line 93 "../src/Widgets/InfoBox.vala"
	_tmp41_ = self->priv->mask;
#line 93 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp41_, TRUE);
#line 94 "../src/Widgets/InfoBox.vala"
	_tmp42_ = self->priv->mask;
#line 94 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp42_, (gfloat) 0);
#line 96 "../src/Widgets/InfoBox.vala"
	_tmp43_ = (GtkLabel*) gtk_label_new (_ ("Router:"));
#line 96 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp43_);
#line 96 "../src/Widgets/InfoBox.vala"
	router_head = _tmp43_;
#line 97 "../src/Widgets/InfoBox.vala"
	_tmp44_ = router_head;
#line 97 "../src/Widgets/InfoBox.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp44_, GTK_ALIGN_END);
#line 99 "../src/Widgets/InfoBox.vala"
	_tmp45_ = (GtkLabel*) gtk_label_new (NULL);
#line 99 "../src/Widgets/InfoBox.vala"
	g_object_ref_sink (_tmp45_);
#line 99 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->router);
#line 99 "../src/Widgets/InfoBox.vala"
	self->priv->router = _tmp45_;
#line 100 "../src/Widgets/InfoBox.vala"
	_tmp46_ = self->priv->router;
#line 100 "../src/Widgets/InfoBox.vala"
	gtk_label_set_selectable (_tmp46_, TRUE);
#line 101 "../src/Widgets/InfoBox.vala"
	_tmp47_ = self->priv->router;
#line 101 "../src/Widgets/InfoBox.vala"
	gtk_label_set_xalign (_tmp47_, (gfloat) 0);
#line 103 "../src/Widgets/InfoBox.vala"
	_tmp48_ = ip4address_head;
#line 103 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp48_, 0, 0, 1, 1);
#line 104 "../src/Widgets/InfoBox.vala"
	_tmp49_ = self->priv->ip4address;
#line 104 "../src/Widgets/InfoBox.vala"
	_tmp50_ = ip4address_head;
#line 104 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp49_, (GtkWidget*) _tmp50_, GTK_POS_RIGHT, 1, 1);
#line 106 "../src/Widgets/InfoBox.vala"
	_tmp51_ = self->priv->ip6address_head;
#line 106 "../src/Widgets/InfoBox.vala"
	_tmp52_ = ip4address_head;
#line 106 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp51_, (GtkWidget*) _tmp52_, GTK_POS_BOTTOM, 1, 1);
#line 107 "../src/Widgets/InfoBox.vala"
	_tmp53_ = self->priv->ip6address;
#line 107 "../src/Widgets/InfoBox.vala"
	_tmp54_ = self->priv->ip6address_head;
#line 107 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp53_, (GtkWidget*) _tmp54_, GTK_POS_RIGHT, 1, 1);
#line 109 "../src/Widgets/InfoBox.vala"
	_tmp55_ = mask_head;
#line 109 "../src/Widgets/InfoBox.vala"
	_tmp56_ = self->priv->ip6address_head;
#line 109 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp55_, (GtkWidget*) _tmp56_, GTK_POS_BOTTOM, 1, 1);
#line 110 "../src/Widgets/InfoBox.vala"
	_tmp57_ = self->priv->mask;
#line 110 "../src/Widgets/InfoBox.vala"
	_tmp58_ = mask_head;
#line 110 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp57_, (GtkWidget*) _tmp58_, GTK_POS_RIGHT, 1, 1);
#line 112 "../src/Widgets/InfoBox.vala"
	_tmp59_ = router_head;
#line 112 "../src/Widgets/InfoBox.vala"
	_tmp60_ = mask_head;
#line 112 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp59_, (GtkWidget*) _tmp60_, GTK_POS_BOTTOM, 1, 1);
#line 113 "../src/Widgets/InfoBox.vala"
	_tmp61_ = self->priv->router;
#line 113 "../src/Widgets/InfoBox.vala"
	_tmp62_ = router_head;
#line 113 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp61_, (GtkWidget*) _tmp62_, GTK_POS_RIGHT, 1, 1);
#line 115 "../src/Widgets/InfoBox.vala"
	_tmp63_ = send_receive_grid;
#line 115 "../src/Widgets/InfoBox.vala"
	_tmp64_ = router_head;
#line 115 "../src/Widgets/InfoBox.vala"
	gtk_grid_attach_next_to ((GtkGrid*) self, (GtkWidget*) _tmp63_, (GtkWidget*) _tmp64_, GTK_POS_BOTTOM, 4, 1);
#line 117 "../src/Widgets/InfoBox.vala"
	_tmp65_ = self->priv->_device;
#line 117 "../src/Widgets/InfoBox.vala"
	g_signal_connect_object (_tmp65_, "state-changed", (GCallback) __network_widgets_info_box___lambda8__nm_device_state_changed, self, 0);
#line 122 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_update_status (self);
#line 123 "../src/Widgets/InfoBox.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (router_head);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (mask_head);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (ip4address_head);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (send_receive_grid);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (received_grid);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (received_head);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (sent_grid);
#line 44 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (sent_head);
#line 44 "../src/Widgets/InfoBox.vala"
	return obj;
#line 1263 "InfoBox.c"
}


static void
network_widgets_info_box_class_init (NetworkWidgetsInfoBoxClass * klass)
{
#line 21 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/Widgets/InfoBox.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWidgetsInfoBox_private_offset);
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_widgets_info_box_get_property;
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_widgets_info_box_set_property;
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->constructor = network_widgets_info_box_constructor;
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (klass)->finalize = network_widgets_info_box_finalize;
#line 21 "../src/Widgets/InfoBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", nm_device_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/InfoBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY, network_widgets_info_box_properties[NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY] = g_param_spec_object ("owner", "owner", "owner", NETWORK_WIDGETS_TYPE_DEVICE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 21 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_UPDATE_SIDEBAR_SIGNAL] = g_signal_new ("update-sidebar", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, NETWORK_WIDGETS_TYPE_DEVICE_ITEM);
#line 21 "../src/Widgets/InfoBox.vala"
	network_widgets_info_box_signals[NETWORK_WIDGETS_INFO_BOX_INFO_CHANGED_SIGNAL] = g_signal_new ("info-changed", NETWORK_WIDGETS_TYPE_INFO_BOX, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1290 "InfoBox.c"
}


static void
network_widgets_info_box_instance_init (NetworkWidgetsInfoBox * self)
{
#line 21 "../src/Widgets/InfoBox.vala"
	self->priv = network_widgets_info_box_get_instance_private (self);
#line 1299 "InfoBox.c"
}


static void
network_widgets_info_box_finalize (GObject * obj)
{
	NetworkWidgetsInfoBox * self;
#line 21 "../src/Widgets/InfoBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 24 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->_device);
#line 25 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->_owner);
#line 27 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip4address);
#line 28 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address);
#line 29 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->mask);
#line 30 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->router);
#line 31 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->sent);
#line 32 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->received);
#line 34 "../src/Widgets/InfoBox.vala"
	_g_object_unref0 (self->priv->ip6address_head);
#line 21 "../src/Widgets/InfoBox.vala"
	G_OBJECT_CLASS (network_widgets_info_box_parent_class)->finalize (obj);
#line 1329 "InfoBox.c"
}


GType
network_widgets_info_box_get_type (void)
{
	static volatile gsize network_widgets_info_box_type_id__volatile = 0;
	if (g_once_init_enter (&network_widgets_info_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkWidgetsInfoBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_widgets_info_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWidgetsInfoBox), 0, (GInstanceInitFunc) network_widgets_info_box_instance_init, NULL };
		GType network_widgets_info_box_type_id;
		network_widgets_info_box_type_id = g_type_register_static (gtk_grid_get_type (), "NetworkWidgetsInfoBox", &g_define_type_info, 0);
		NetworkWidgetsInfoBox_private_offset = g_type_add_instance_private (network_widgets_info_box_type_id, sizeof (NetworkWidgetsInfoBoxPrivate));
		g_once_init_leave (&network_widgets_info_box_type_id__volatile, network_widgets_info_box_type_id);
	}
	return network_widgets_info_box_type_id__volatile;
}


static void
_vala_network_widgets_info_box_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 21 "../src/Widgets/InfoBox.vala"
	switch (property_id) {
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		g_value_set_object (value, network_widgets_info_box_get_device (self));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		g_value_set_object (value, network_widgets_info_box_get_owner (self));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1370 "InfoBox.c"
		default:
#line 21 "../src/Widgets/InfoBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1376 "InfoBox.c"
	}
}


static void
_vala_network_widgets_info_box_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NetworkWidgetsInfoBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_WIDGETS_TYPE_INFO_BOX, NetworkWidgetsInfoBox);
#line 21 "../src/Widgets/InfoBox.vala"
	switch (property_id) {
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_DEVICE_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		network_widgets_info_box_set_device (self, g_value_get_object (value));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 21 "../src/Widgets/InfoBox.vala"
		case NETWORK_WIDGETS_INFO_BOX_OWNER_PROPERTY:
#line 21 "../src/Widgets/InfoBox.vala"
		network_widgets_info_box_set_owner (self, g_value_get_object (value));
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1403 "InfoBox.c"
		default:
#line 21 "../src/Widgets/InfoBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/Widgets/InfoBox.vala"
		break;
#line 1409 "InfoBox.c"
	}
}



