/* WifiMenuItem.c generated by valac 0.42.5, the Vala compiler
 * generated from WifiMenuItem.vala, do not modify */

/*-
 * Copyright (c) 2015-2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <NetworkManager.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define NETWORK_TYPE_WIFI_MENU_ITEM (network_wifi_menu_item_get_type ())
#define NETWORK_WIFI_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem))
#define NETWORK_WIFI_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemClass))
#define NETWORK_IS_WIFI_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NETWORK_TYPE_WIFI_MENU_ITEM))
#define NETWORK_IS_WIFI_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NETWORK_TYPE_WIFI_MENU_ITEM))
#define NETWORK_WIFI_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItemClass))

typedef struct _NetworkWifiMenuItem NetworkWifiMenuItem;
typedef struct _NetworkWifiMenuItemClass NetworkWifiMenuItemClass;
typedef struct _NetworkWifiMenuItemPrivate NetworkWifiMenuItemPrivate;
typedef enum  {
	NETWORK_STATE_DISCONNECTED,
	NETWORK_STATE_WIRED_UNPLUGGED,
	NETWORK_STATE_CONNECTED_WIRED,
	NETWORK_STATE_CONNECTED_VPN,
	NETWORK_STATE_CONNECTED_MOBILE,
	NETWORK_STATE_CONNECTED_WIFI,
	NETWORK_STATE_CONNECTED_WIFI_WEAK,
	NETWORK_STATE_CONNECTED_WIFI_OK,
	NETWORK_STATE_CONNECTED_WIFI_GOOD,
	NETWORK_STATE_CONNECTED_WIFI_EXCELLENT,
	NETWORK_STATE_CONNECTING_WIFI,
	NETWORK_STATE_CONNECTING_WIRED,
	NETWORK_STATE_CONNECTING_MOBILE,
	NETWORK_STATE_CONNECTING_VPN,
	NETWORK_STATE_FAILED_WIRED,
	NETWORK_STATE_FAILED_WIFI,
	NETWORK_STATE_FAILED_MOBILE,
	NETWORK_STATE_FAILED_VPN
} NetworkState;


#define NETWORK_TYPE_STATE (network_state_get_type ())
enum  {
	NETWORK_WIFI_MENU_ITEM_0_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_AP_PROPERTY,
	NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL,
	NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS
};
static guint network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_NUM_SIGNALS] = {0};

struct _NetworkWifiMenuItem {
	GtkListBoxRow parent_instance;
	NetworkWifiMenuItemPrivate * priv;
	gboolean is_secured;
};

struct _NetworkWifiMenuItemClass {
	GtkListBoxRowClass parent_class;
};

struct _NetworkWifiMenuItemPrivate {
	GeeLinkedList* _ap;
	NetworkState _state;
	gboolean _active;
	gboolean show_icons;
	NMAccessPoint* _tmp_ap;
	GtkRadioButton* radio_button;
	GtkImage* img_strength;
	GtkImage* lock_img;
	GtkImage* error_img;
	GtkSpinner* spinner;
};


static gint NetworkWifiMenuItem_private_offset;
static gpointer network_wifi_menu_item_parent_class = NULL;

GType network_wifi_menu_item_get_type (void) G_GNUC_CONST;
GType network_state_get_type (void) G_GNUC_CONST;
NetworkWifiMenuItem* network_wifi_menu_item_new (NMAccessPoint* ap,
                                                 NetworkWifiMenuItem* previous);
NetworkWifiMenuItem* network_wifi_menu_item_construct (GType object_type,
                                                       NMAccessPoint* ap,
                                                       NetworkWifiMenuItem* previous);
void network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                                    NMAccessPoint* ap);
static void network_wifi_menu_item_update (NetworkWifiMenuItem* self);
static void _network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static gboolean __lambda13_ (NetworkWifiMenuItem* self,
                      GtkWidget* b,
                      GdkEventButton* ev);
static gboolean ___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
NetworkWifiMenuItem* network_wifi_menu_item_new_blank (void);
NetworkWifiMenuItem* network_wifi_menu_item_construct_blank (GType object_type);
static void network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self);
NMAccessPoint* network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self);
static gchar* network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self,
                                                  guint8 strength);
guint8 network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
NetworkState network_wifi_menu_item_get_state (NetworkWifiMenuItem* self);
static void network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                       GtkWidget* w);
void network_wifi_menu_item_hide_icons (NetworkWifiMenuItem* self);
gboolean network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                           NMAccessPoint* ap);
GBytes* network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self);
void network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                       NetworkState value);
gboolean network_wifi_menu_item_get_active (NetworkWifiMenuItem* self);
void network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                        gboolean value);
static void network_wifi_menu_item_finalize (GObject * obj);
static void _vala_network_wifi_menu_item_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_network_wifi_menu_item_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);


static inline gpointer
network_wifi_menu_item_get_instance_private (NetworkWifiMenuItem* self)
{
	return G_STRUCT_MEMBER_P (self, NetworkWifiMenuItem_private_offset);
}


static void
_network_wifi_menu_item_update_g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 93 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update ((NetworkWifiMenuItem*) self);
#line 177 "WifiMenuItem.c"
}


static gboolean
__lambda13_ (NetworkWifiMenuItem* self,
             GtkWidget* b,
             GdkEventButton* ev)
{
	gboolean result = FALSE;
#line 96 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 96 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ev != NULL, FALSE);
#line 97 "../src/Widgets/WifiMenuItem.vala"
	g_signal_emit (self, network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL], 0);
#line 98 "../src/Widgets/WifiMenuItem.vala"
	result = FALSE;
#line 98 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 197 "WifiMenuItem.c"
}


static gboolean
___lambda13__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda13_ ((NetworkWifiMenuItem*) self, _sender, event);
#line 96 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 210 "WifiMenuItem.c"
}


NetworkWifiMenuItem*
network_wifi_menu_item_construct (GType object_type,
                                  NMAccessPoint* ap,
                                  NetworkWifiMenuItem* previous)
{
	NetworkWifiMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkSpinner* _tmp10_;
	GtkSpinner* _tmp11_;
	GtkSpinner* _tmp12_;
	GtkSpinner* _tmp13_;
	GtkSpinner* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	GtkGrid* main_grid = NULL;
	GtkGrid* _tmp17_;
	GtkRadioButton* _tmp18_;
	GtkSpinner* _tmp19_;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	GtkImage* _tmp22_;
	GeeLinkedList* _tmp23_;
	GtkStyleContext* _tmp24_;
	GtkRadioButton* _tmp25_;
	GtkRadioButton* _tmp26_;
#line 52 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, NULL);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 53 "../src/Widgets/WifiMenuItem.vala"
	self->priv->radio_button = _tmp0_;
#line 54 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = self->priv->radio_button;
#line 54 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 55 "../src/Widgets/WifiMenuItem.vala"
	if (previous != NULL) {
#line 263 "WifiMenuItem.c"
		GtkRadioButton* _tmp2_;
		GtkRadioButton* _tmp3_;
		GSList* _tmp4_;
#line 56 "../src/Widgets/WifiMenuItem.vala"
		_tmp2_ = self->priv->radio_button;
#line 56 "../src/Widgets/WifiMenuItem.vala"
		_tmp3_ = previous->priv->radio_button;
#line 56 "../src/Widgets/WifiMenuItem.vala"
		_tmp4_ = gtk_radio_button_get_group (_tmp3_);
#line 56 "../src/Widgets/WifiMenuItem.vala"
		gtk_radio_button_set_group (_tmp2_, _tmp4_);
#line 275 "WifiMenuItem.c"
	}
#line 59 "../src/Widgets/WifiMenuItem.vala"
	_tmp5_ = (GtkImage*) gtk_image_new ();
#line 59 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp5_);
#line 59 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 59 "../src/Widgets/WifiMenuItem.vala"
	self->priv->img_strength = _tmp5_;
#line 60 "../src/Widgets/WifiMenuItem.vala"
	_tmp6_ = self->priv->img_strength;
#line 60 "../src/Widgets/WifiMenuItem.vala"
	g_object_set (_tmp6_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	_tmp7_ = (GtkImage*) gtk_image_new_from_icon_name ("channel-insecure-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp7_);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 62 "../src/Widgets/WifiMenuItem.vala"
	self->priv->lock_img = _tmp7_;
#line 65 "../src/Widgets/WifiMenuItem.vala"
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name ("process-error-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 65 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp8_);
#line 65 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 65 "../src/Widgets/WifiMenuItem.vala"
	self->priv->error_img = _tmp8_;
#line 66 "../src/Widgets/WifiMenuItem.vala"
	_tmp9_ = self->priv->error_img;
#line 66 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp9_, _ ("This wireless network could not be connected to."));
#line 68 "../src/Widgets/WifiMenuItem.vala"
	_tmp10_ = (GtkSpinner*) gtk_spinner_new ();
#line 68 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp10_);
#line 68 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 68 "../src/Widgets/WifiMenuItem.vala"
	self->priv->spinner = _tmp10_;
#line 69 "../src/Widgets/WifiMenuItem.vala"
	_tmp11_ = self->priv->spinner;
#line 69 "../src/Widgets/WifiMenuItem.vala"
	gtk_spinner_start (_tmp11_);
#line 70 "../src/Widgets/WifiMenuItem.vala"
	_tmp12_ = self->priv->spinner;
#line 70 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
#line 71 "../src/Widgets/WifiMenuItem.vala"
	_tmp13_ = self->priv->spinner;
#line 71 "../src/Widgets/WifiMenuItem.vala"
	_tmp14_ = self->priv->spinner;
#line 71 "../src/Widgets/WifiMenuItem.vala"
	_tmp15_ = gtk_widget_get_visible ((GtkWidget*) _tmp14_);
#line 71 "../src/Widgets/WifiMenuItem.vala"
	_tmp16_ = _tmp15_;
#line 71 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp13_, !_tmp16_);
#line 73 "../src/Widgets/WifiMenuItem.vala"
	_tmp17_ = (GtkGrid*) gtk_grid_new ();
#line 73 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp17_);
#line 73 "../src/Widgets/WifiMenuItem.vala"
	main_grid = _tmp17_;
#line 74 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_valign ((GtkWidget*) main_grid, GTK_ALIGN_CENTER);
#line 75 "../src/Widgets/WifiMenuItem.vala"
	gtk_grid_set_column_spacing (main_grid, 6);
#line 76 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_margin_start ((GtkWidget*) main_grid, 6);
#line 77 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_margin_end ((GtkWidget*) main_grid, 6);
#line 78 "../src/Widgets/WifiMenuItem.vala"
	_tmp18_ = self->priv->radio_button;
#line 78 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp18_);
#line 79 "../src/Widgets/WifiMenuItem.vala"
	_tmp19_ = self->priv->spinner;
#line 79 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp19_);
#line 80 "../src/Widgets/WifiMenuItem.vala"
	_tmp20_ = self->priv->error_img;
#line 80 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp20_);
#line 81 "../src/Widgets/WifiMenuItem.vala"
	_tmp21_ = self->priv->lock_img;
#line 81 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp21_);
#line 82 "../src/Widgets/WifiMenuItem.vala"
	_tmp22_ = self->priv->img_strength;
#line 82 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) main_grid, (GtkWidget*) _tmp22_);
#line 84 "../src/Widgets/WifiMenuItem.vala"
	_tmp23_ = gee_linked_list_new (nm_access_point_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 84 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_ap);
#line 84 "../src/Widgets/WifiMenuItem.vala"
	self->priv->_ap = _tmp23_;
#line 87 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_add_ap (self, ap);
#line 89 "../src/Widgets/WifiMenuItem.vala"
	_tmp24_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 89 "../src/Widgets/WifiMenuItem.vala"
	gtk_style_context_add_class (_tmp24_, "menuitem");
#line 90 "../src/Widgets/WifiMenuItem.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) main_grid);
#line 92 "../src/Widgets/WifiMenuItem.vala"
	_tmp25_ = self->priv->radio_button;
#line 92 "../src/Widgets/WifiMenuItem.vala"
	g_object_bind_property_with_closures ((GObject*) self, "active", (GObject*) _tmp25_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 93 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::state", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 94 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GObject*) self, "notify::active", (GCallback) _network_wifi_menu_item_update_g_object_notify, self, 0);
#line 96 "../src/Widgets/WifiMenuItem.vala"
	_tmp26_ = self->priv->radio_button;
#line 96 "../src/Widgets/WifiMenuItem.vala"
	g_signal_connect_object ((GtkWidget*) _tmp26_, "button-release-event", (GCallback) ___lambda13__gtk_widget_button_release_event, self, 0);
#line 101 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (main_grid);
#line 52 "../src/Widgets/WifiMenuItem.vala"
	return self;
#line 401 "WifiMenuItem.c"
}


NetworkWifiMenuItem*
network_wifi_menu_item_new (NMAccessPoint* ap,
                            NetworkWifiMenuItem* previous)
{
#line 52 "../src/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct (NETWORK_TYPE_WIFI_MENU_ITEM, ap, previous);
#line 411 "WifiMenuItem.c"
}


/**
     * Only used for an item which is not displayed: hacky way to have no radio button selected.
     **/
NetworkWifiMenuItem*
network_wifi_menu_item_construct_blank (GType object_type)
{
	NetworkWifiMenuItem * self = NULL;
	GtkRadioButton* _tmp0_;
#line 107 "../src/Widgets/WifiMenuItem.vala"
	self = (NetworkWifiMenuItem*) g_object_new (object_type, NULL);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	g_object_ref_sink (_tmp0_);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 108 "../src/Widgets/WifiMenuItem.vala"
	self->priv->radio_button = _tmp0_;
#line 107 "../src/Widgets/WifiMenuItem.vala"
	return self;
#line 435 "WifiMenuItem.c"
}


NetworkWifiMenuItem*
network_wifi_menu_item_new_blank (void)
{
#line 107 "../src/Widgets/WifiMenuItem.vala"
	return network_wifi_menu_item_construct_blank (NETWORK_TYPE_WIFI_MENU_ITEM);
#line 444 "WifiMenuItem.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 113 "../src/Widgets/WifiMenuItem.vala"
	return self ? g_object_ref (self) : NULL;
#line 453 "WifiMenuItem.c"
}


static void
network_wifi_menu_item_update_tmp_ap (NetworkWifiMenuItem* self)
{
	guint8 strength = 0U;
#line 111 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 465 "WifiMenuItem.c"
	{
		GeeLinkedList* _ap_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _ap_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ap_index = 0;
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_tmp0_ = self->priv->_ap;
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_ap_list = _tmp1_;
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_tmp2_ = _ap_list;
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_tmp4_ = _tmp3_;
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_ap_size = _tmp4_;
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_ap_index = -1;
#line 113 "../src/Widgets/WifiMenuItem.vala"
		while (TRUE) {
#line 493 "WifiMenuItem.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			NMAccessPoint* _tmp11_ = NULL;
			guint8 _tmp12_;
			NMAccessPoint* _tmp13_;
			guint8 _tmp14_;
			guint8 _tmp15_;
			NMAccessPoint* _tmp18_;
			guint8 _tmp19_;
			NMAccessPoint* _tmp20_;
			guint8 _tmp21_;
			guint8 _tmp22_;
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_tmp5_ = _ap_index;
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_ap_index = _tmp5_ + 1;
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_tmp6_ = _ap_index;
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_tmp7_ = _ap_size;
#line 113 "../src/Widgets/WifiMenuItem.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 113 "../src/Widgets/WifiMenuItem.vala"
				break;
#line 523 "WifiMenuItem.c"
			}
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_tmp8_ = _ap_list;
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_tmp9_ = _ap_index;
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 113 "../src/Widgets/WifiMenuItem.vala"
			ap = (NMAccessPoint*) _tmp10_;
#line 114 "../src/Widgets/WifiMenuItem.vala"
			_tmp12_ = strength;
#line 114 "../src/Widgets/WifiMenuItem.vala"
			_tmp13_ = ap;
#line 114 "../src/Widgets/WifiMenuItem.vala"
			_tmp14_ = nm_access_point_get_strength (_tmp13_);
#line 114 "../src/Widgets/WifiMenuItem.vala"
			_tmp15_ = _tmp14_;
#line 114 "../src/Widgets/WifiMenuItem.vala"
			if (_tmp12_ > _tmp15_) {
#line 543 "WifiMenuItem.c"
				NMAccessPoint* _tmp16_;
#line 114 "../src/Widgets/WifiMenuItem.vala"
				_tmp16_ = self->priv->_tmp_ap;
#line 114 "../src/Widgets/WifiMenuItem.vala"
				_tmp11_ = _tmp16_;
#line 549 "WifiMenuItem.c"
			} else {
				NMAccessPoint* _tmp17_;
#line 114 "../src/Widgets/WifiMenuItem.vala"
				_tmp17_ = ap;
#line 114 "../src/Widgets/WifiMenuItem.vala"
				_tmp11_ = _tmp17_;
#line 556 "WifiMenuItem.c"
			}
#line 114 "../src/Widgets/WifiMenuItem.vala"
			_tmp18_ = _g_object_ref0 (_tmp11_);
#line 114 "../src/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (self->priv->_tmp_ap);
#line 114 "../src/Widgets/WifiMenuItem.vala"
			self->priv->_tmp_ap = _tmp18_;
#line 115 "../src/Widgets/WifiMenuItem.vala"
			_tmp19_ = strength;
#line 115 "../src/Widgets/WifiMenuItem.vala"
			_tmp20_ = ap;
#line 115 "../src/Widgets/WifiMenuItem.vala"
			_tmp21_ = nm_access_point_get_strength (_tmp20_);
#line 115 "../src/Widgets/WifiMenuItem.vala"
			_tmp22_ = _tmp21_;
#line 115 "../src/Widgets/WifiMenuItem.vala"
			strength = MAX (_tmp19_, _tmp22_);
#line 113 "../src/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (ap);
#line 576 "WifiMenuItem.c"
		}
#line 113 "../src/Widgets/WifiMenuItem.vala"
		_g_object_unref0 (_ap_list);
#line 580 "WifiMenuItem.c"
	}
}


static void
network_wifi_menu_item_update (NetworkWifiMenuItem* self)
{
	GtkRadioButton* _tmp0_;
	NMAccessPoint* _tmp1_;
	NMAccessPoint* _tmp2_;
	GBytes* _tmp3_;
	gsize _tmp4_ = 0;
	guint8* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	NetworkState _tmp36_;
#line 119 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->radio_button;
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = network_wifi_menu_item_get_ap (self);
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_tmp2_ = _tmp1_;
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_tmp3_ = nm_access_point_get_ssid (_tmp2_);
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_tmp5_ = g_bytes_get_data (_tmp3_, &_tmp4_);
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_tmp6_ = nm_utils_ssid_to_utf8 (_tmp5_, (gsize) _tmp4_);
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_tmp7_ = _tmp6_;
#line 120 "../src/Widgets/WifiMenuItem.vala"
	gtk_button_set_label ((GtkButton*) _tmp0_, _tmp7_);
#line 120 "../src/Widgets/WifiMenuItem.vala"
	_g_free0 (_tmp7_);
#line 122 "../src/Widgets/WifiMenuItem.vala"
	_tmp8_ = self->priv->show_icons;
#line 122 "../src/Widgets/WifiMenuItem.vala"
	if (_tmp8_) {
#line 622 "WifiMenuItem.c"
		GtkImage* _tmp9_;
		guint8 _tmp10_;
		guint8 _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GtkImage* _tmp18_;
		NM80211ApSecurityFlags flags = 0;
		NMAccessPoint* _tmp19_;
		NMAccessPoint* _tmp20_;
		NM80211ApSecurityFlags _tmp21_;
		GtkImage* _tmp28_;
		gboolean _tmp29_;
		GtkImage* _tmp30_;
		GtkImage* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp33_;
		GtkImage* _tmp34_;
		GtkSpinner* _tmp35_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp9_ = self->priv->img_strength;
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp10_ = network_wifi_menu_item_get_strength (self);
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp11_ = _tmp10_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp12_ = network_wifi_menu_item_strength_to_string (self, _tmp11_);
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp13_ = _tmp12_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp14_ = g_strconcat ("network-wireless-signal-", _tmp13_, NULL);
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp15_ = _tmp14_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp16_ = g_strconcat (_tmp15_, "-symbolic", NULL);
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_tmp17_ = _tmp16_;
#line 123 "../src/Widgets/WifiMenuItem.vala"
		g_object_set (_tmp9_, "icon-name", _tmp17_, NULL);
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_g_free0 (_tmp17_);
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_g_free0 (_tmp15_);
#line 123 "../src/Widgets/WifiMenuItem.vala"
		_g_free0 (_tmp13_);
#line 124 "../src/Widgets/WifiMenuItem.vala"
		_tmp18_ = self->priv->img_strength;
#line 124 "../src/Widgets/WifiMenuItem.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp18_);
#line 126 "../src/Widgets/WifiMenuItem.vala"
		_tmp19_ = network_wifi_menu_item_get_ap (self);
#line 126 "../src/Widgets/WifiMenuItem.vala"
		_tmp20_ = _tmp19_;
#line 126 "../src/Widgets/WifiMenuItem.vala"
		flags = nm_access_point_get_wpa_flags (_tmp20_);
#line 127 "../src/Widgets/WifiMenuItem.vala"
		self->is_secured = FALSE;
#line 128 "../src/Widgets/WifiMenuItem.vala"
		_tmp21_ = flags;
#line 128 "../src/Widgets/WifiMenuItem.vala"
		if ((_tmp21_ & NM_802_11_AP_SEC_GROUP_WEP40) == NM_802_11_AP_SEC_GROUP_WEP40) {
#line 129 "../src/Widgets/WifiMenuItem.vala"
			self->is_secured = TRUE;
#line 130 "../src/Widgets/WifiMenuItem.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 40/64-bit WEP encryption"));
#line 691 "WifiMenuItem.c"
		} else {
			NM80211ApSecurityFlags _tmp22_;
#line 131 "../src/Widgets/WifiMenuItem.vala"
			_tmp22_ = flags;
#line 131 "../src/Widgets/WifiMenuItem.vala"
			if ((_tmp22_ & NM_802_11_AP_SEC_GROUP_WEP104) == NM_802_11_AP_SEC_GROUP_WEP104) {
#line 132 "../src/Widgets/WifiMenuItem.vala"
				self->is_secured = TRUE;
#line 133 "../src/Widgets/WifiMenuItem.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses 104/128-bit WEP encryption"));
#line 702 "WifiMenuItem.c"
			} else {
				NM80211ApSecurityFlags _tmp23_;
#line 134 "../src/Widgets/WifiMenuItem.vala"
				_tmp23_ = flags;
#line 134 "../src/Widgets/WifiMenuItem.vala"
				if ((_tmp23_ & NM_802_11_AP_SEC_KEY_MGMT_PSK) == NM_802_11_AP_SEC_KEY_MGMT_PSK) {
#line 135 "../src/Widgets/WifiMenuItem.vala"
					self->is_secured = TRUE;
#line 136 "../src/Widgets/WifiMenuItem.vala"
					gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses WPA encryption"));
#line 713 "WifiMenuItem.c"
				} else {
					gboolean _tmp24_ = FALSE;
					NM80211ApSecurityFlags _tmp25_;
#line 137 "../src/Widgets/WifiMenuItem.vala"
					_tmp25_ = flags;
#line 137 "../src/Widgets/WifiMenuItem.vala"
					if (_tmp25_ != NM_802_11_AP_SEC_NONE) {
#line 137 "../src/Widgets/WifiMenuItem.vala"
						_tmp24_ = TRUE;
#line 723 "WifiMenuItem.c"
					} else {
						NMAccessPoint* _tmp26_;
						NMAccessPoint* _tmp27_;
#line 137 "../src/Widgets/WifiMenuItem.vala"
						_tmp26_ = network_wifi_menu_item_get_ap (self);
#line 137 "../src/Widgets/WifiMenuItem.vala"
						_tmp27_ = _tmp26_;
#line 137 "../src/Widgets/WifiMenuItem.vala"
						_tmp24_ = nm_access_point_get_rsn_flags (_tmp27_) != NM_802_11_AP_SEC_NONE;
#line 733 "WifiMenuItem.c"
					}
#line 137 "../src/Widgets/WifiMenuItem.vala"
					if (_tmp24_) {
#line 138 "../src/Widgets/WifiMenuItem.vala"
						self->is_secured = TRUE;
#line 139 "../src/Widgets/WifiMenuItem.vala"
						gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network uses encryption"));
#line 741 "WifiMenuItem.c"
					} else {
#line 141 "../src/Widgets/WifiMenuItem.vala"
						gtk_widget_set_tooltip_text ((GtkWidget*) self, _ ("This network is unsecured"));
#line 745 "WifiMenuItem.c"
					}
				}
			}
		}
#line 144 "../src/Widgets/WifiMenuItem.vala"
		_tmp28_ = self->priv->lock_img;
#line 144 "../src/Widgets/WifiMenuItem.vala"
		_tmp29_ = self->is_secured;
#line 144 "../src/Widgets/WifiMenuItem.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp28_, !_tmp29_);
#line 145 "../src/Widgets/WifiMenuItem.vala"
		_tmp30_ = self->priv->lock_img;
#line 145 "../src/Widgets/WifiMenuItem.vala"
		_tmp31_ = self->priv->lock_img;
#line 145 "../src/Widgets/WifiMenuItem.vala"
		_tmp32_ = gtk_widget_get_visible ((GtkWidget*) _tmp31_);
#line 145 "../src/Widgets/WifiMenuItem.vala"
		_tmp33_ = _tmp32_;
#line 145 "../src/Widgets/WifiMenuItem.vala"
		gtk_widget_set_no_show_all ((GtkWidget*) _tmp30_, !_tmp33_);
#line 147 "../src/Widgets/WifiMenuItem.vala"
		_tmp34_ = self->priv->error_img;
#line 147 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp34_);
#line 148 "../src/Widgets/WifiMenuItem.vala"
		_tmp35_ = self->priv->spinner;
#line 148 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp35_);
#line 774 "WifiMenuItem.c"
	}
#line 151 "../src/Widgets/WifiMenuItem.vala"
	_tmp36_ = self->priv->_state;
#line 151 "../src/Widgets/WifiMenuItem.vala"
	switch (_tmp36_) {
#line 151 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_STATE_FAILED_WIFI:
#line 782 "WifiMenuItem.c"
		{
			GtkImage* _tmp37_;
#line 153 "../src/Widgets/WifiMenuItem.vala"
			_tmp37_ = self->priv->error_img;
#line 153 "../src/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp37_);
#line 154 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 791 "WifiMenuItem.c"
		}
#line 151 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_STATE_CONNECTING_WIFI:
#line 795 "WifiMenuItem.c"
		{
			GtkSpinner* _tmp38_;
			GtkRadioButton* _tmp39_;
			gboolean _tmp40_;
			gboolean _tmp41_;
#line 156 "../src/Widgets/WifiMenuItem.vala"
			_tmp38_ = self->priv->spinner;
#line 156 "../src/Widgets/WifiMenuItem.vala"
			network_wifi_menu_item_show_item (self, (GtkWidget*) _tmp38_);
#line 157 "../src/Widgets/WifiMenuItem.vala"
			_tmp39_ = self->priv->radio_button;
#line 157 "../src/Widgets/WifiMenuItem.vala"
			_tmp40_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp39_);
#line 157 "../src/Widgets/WifiMenuItem.vala"
			_tmp41_ = _tmp40_;
#line 157 "../src/Widgets/WifiMenuItem.vala"
			if (!_tmp41_) {
#line 158 "../src/Widgets/WifiMenuItem.vala"
				g_critical ("WifiMenuItem.vala:158: An access point is being connected but not acti" \
"ve.");
#line 815 "WifiMenuItem.c"
			}
#line 161 "../src/Widgets/WifiMenuItem.vala"
			break;
#line 819 "WifiMenuItem.c"
		}
		default:
#line 151 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 824 "WifiMenuItem.c"
	}
}


void
network_wifi_menu_item_hide_icons (NetworkWifiMenuItem* self)
{
	GtkImage* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
#line 165 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 166 "../src/Widgets/WifiMenuItem.vala"
	self->priv->show_icons = FALSE;
#line 167 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->error_img;
#line 167 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp0_);
#line 168 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = self->priv->lock_img;
#line 168 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp1_);
#line 169 "../src/Widgets/WifiMenuItem.vala"
	_tmp2_ = self->priv->img_strength;
#line 169 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_hide_item (self, (GtkWidget*) _tmp2_);
#line 851 "WifiMenuItem.c"
}


static void
network_wifi_menu_item_show_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 172 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 173 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (w, TRUE);
#line 174 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 174 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 174 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 873 "WifiMenuItem.c"
}


static void
network_wifi_menu_item_hide_item (NetworkWifiMenuItem* self,
                                  GtkWidget* w)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 177 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 177 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (w != NULL);
#line 178 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_visible (w, FALSE);
#line 179 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = gtk_widget_get_visible (w);
#line 179 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = _tmp0_;
#line 179 "../src/Widgets/WifiMenuItem.vala"
	gtk_widget_set_no_show_all (w, !_tmp1_);
#line 895 "WifiMenuItem.c"
}


void
network_wifi_menu_item_add_ap (NetworkWifiMenuItem* self,
                               NMAccessPoint* ap)
{
	GeeLinkedList* _tmp0_;
#line 182 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (ap != NULL);
#line 183 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 183 "../src/Widgets/WifiMenuItem.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, ap);
#line 184 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_tmp_ap (self);
#line 185 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update (self);
#line 916 "WifiMenuItem.c"
}


static gchar*
network_wifi_menu_item_strength_to_string (NetworkWifiMenuItem* self,
                                           guint8 strength)
{
	gchar* result = NULL;
#line 188 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 189 "../src/Widgets/WifiMenuItem.vala"
	if (((gint) strength) < 30) {
#line 929 "WifiMenuItem.c"
		gchar* _tmp0_;
#line 190 "../src/Widgets/WifiMenuItem.vala"
		_tmp0_ = g_strdup ("weak");
#line 190 "../src/Widgets/WifiMenuItem.vala"
		result = _tmp0_;
#line 190 "../src/Widgets/WifiMenuItem.vala"
		return result;
#line 937 "WifiMenuItem.c"
	} else {
#line 191 "../src/Widgets/WifiMenuItem.vala"
		if (((gint) strength) < 55) {
#line 941 "WifiMenuItem.c"
			gchar* _tmp1_;
#line 192 "../src/Widgets/WifiMenuItem.vala"
			_tmp1_ = g_strdup ("ok");
#line 192 "../src/Widgets/WifiMenuItem.vala"
			result = _tmp1_;
#line 192 "../src/Widgets/WifiMenuItem.vala"
			return result;
#line 949 "WifiMenuItem.c"
		} else {
#line 193 "../src/Widgets/WifiMenuItem.vala"
			if (((gint) strength) < 80) {
#line 953 "WifiMenuItem.c"
				gchar* _tmp2_;
#line 194 "../src/Widgets/WifiMenuItem.vala"
				_tmp2_ = g_strdup ("good");
#line 194 "../src/Widgets/WifiMenuItem.vala"
				result = _tmp2_;
#line 194 "../src/Widgets/WifiMenuItem.vala"
				return result;
#line 961 "WifiMenuItem.c"
			} else {
				gchar* _tmp3_;
#line 196 "../src/Widgets/WifiMenuItem.vala"
				_tmp3_ = g_strdup ("excellent");
#line 196 "../src/Widgets/WifiMenuItem.vala"
				result = _tmp3_;
#line 196 "../src/Widgets/WifiMenuItem.vala"
				return result;
#line 970 "WifiMenuItem.c"
			}
		}
	}
}


gboolean
network_wifi_menu_item_remove_ap (NetworkWifiMenuItem* self,
                                  NMAccessPoint* ap)
{
	gboolean result = FALSE;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 200 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 200 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (ap != NULL, FALSE);
#line 201 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_ap;
#line 201 "../src/Widgets/WifiMenuItem.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, ap);
#line 202 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_update_tmp_ap (self);
#line 203 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = self->priv->_ap;
#line 203 "../src/Widgets/WifiMenuItem.vala"
	_tmp2_ = gee_collection_get_is_empty ((GeeCollection*) _tmp1_);
#line 203 "../src/Widgets/WifiMenuItem.vala"
	_tmp3_ = _tmp2_;
#line 203 "../src/Widgets/WifiMenuItem.vala"
	result = !_tmp3_;
#line 203 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 1006 "WifiMenuItem.c"
}


GBytes*
network_wifi_menu_item_get_ssid (NetworkWifiMenuItem* self)
{
	GBytes* result;
	NMAccessPoint* _tmp0_;
	GBytes* _tmp1_;
#line 22 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_tmp_ap;
#line 23 "../src/Widgets/WifiMenuItem.vala"
	_tmp1_ = nm_access_point_get_ssid (_tmp0_);
#line 23 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp1_;
#line 23 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 1026 "WifiMenuItem.c"
}


NetworkState
network_wifi_menu_item_get_state (NetworkWifiMenuItem* self)
{
	NetworkState result;
	NetworkState _tmp0_;
#line 29 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 29 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_state;
#line 29 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 29 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 1043 "WifiMenuItem.c"
}


void
network_wifi_menu_item_set_state (NetworkWifiMenuItem* self,
                                  NetworkState value)
{
#line 29 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Widgets/WifiMenuItem.vala"
	if (network_wifi_menu_item_get_state (self) != value) {
#line 29 "../src/Widgets/WifiMenuItem.vala"
		self->priv->_state = value;
#line 29 "../src/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY]);
#line 1059 "WifiMenuItem.c"
	}
}


gboolean
network_wifi_menu_item_get_active (NetworkWifiMenuItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 30 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 30 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_active;
#line 30 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 30 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 1077 "WifiMenuItem.c"
}


void
network_wifi_menu_item_set_active (NetworkWifiMenuItem* self,
                                   gboolean value)
{
#line 30 "../src/Widgets/WifiMenuItem.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Widgets/WifiMenuItem.vala"
	if (network_wifi_menu_item_get_active (self) != value) {
#line 30 "../src/Widgets/WifiMenuItem.vala"
		self->priv->_active = value;
#line 30 "../src/Widgets/WifiMenuItem.vala"
		g_object_notify_by_pspec ((GObject *) self, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY]);
#line 1093 "WifiMenuItem.c"
	}
}


guint8
network_wifi_menu_item_get_strength (NetworkWifiMenuItem* self)
{
	guint8 result;
	guint8 strength = 0U;
	guint8 _tmp13_;
#line 32 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 33 "../src/Widgets/WifiMenuItem.vala"
	strength = (guint8) 0;
#line 1108 "WifiMenuItem.c"
	{
		GeeLinkedList* _ap_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _ap_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ap_index = 0;
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_tmp0_ = self->priv->_ap;
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_ap_list = _tmp1_;
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_tmp2_ = _ap_list;
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_tmp4_ = _tmp3_;
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_ap_size = _tmp4_;
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_ap_index = -1;
#line 34 "../src/Widgets/WifiMenuItem.vala"
		while (TRUE) {
#line 1136 "WifiMenuItem.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			NMAccessPoint* ap = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			guint8 _tmp11_;
			NMAccessPoint* _tmp12_;
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_tmp5_ = _ap_index;
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_ap_index = _tmp5_ + 1;
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_tmp6_ = _ap_index;
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_tmp7_ = _ap_size;
#line 34 "../src/Widgets/WifiMenuItem.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 34 "../src/Widgets/WifiMenuItem.vala"
				break;
#line 1158 "WifiMenuItem.c"
			}
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_tmp8_ = _ap_list;
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_tmp9_ = _ap_index;
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 34 "../src/Widgets/WifiMenuItem.vala"
			ap = (NMAccessPoint*) _tmp10_;
#line 35 "../src/Widgets/WifiMenuItem.vala"
			_tmp11_ = strength;
#line 35 "../src/Widgets/WifiMenuItem.vala"
			_tmp12_ = ap;
#line 35 "../src/Widgets/WifiMenuItem.vala"
			strength = MAX (_tmp11_, nm_access_point_get_strength (_tmp12_));
#line 34 "../src/Widgets/WifiMenuItem.vala"
			_g_object_unref0 (ap);
#line 1176 "WifiMenuItem.c"
		}
#line 34 "../src/Widgets/WifiMenuItem.vala"
		_g_object_unref0 (_ap_list);
#line 1180 "WifiMenuItem.c"
	}
#line 37 "../src/Widgets/WifiMenuItem.vala"
	_tmp13_ = strength;
#line 37 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp13_;
#line 37 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 1188 "WifiMenuItem.c"
}


NMAccessPoint*
network_wifi_menu_item_get_ap (NetworkWifiMenuItem* self)
{
	NMAccessPoint* result;
	NMAccessPoint* _tmp0_;
#line 43 "../src/Widgets/WifiMenuItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 43 "../src/Widgets/WifiMenuItem.vala"
	_tmp0_ = self->priv->_tmp_ap;
#line 43 "../src/Widgets/WifiMenuItem.vala"
	result = _tmp0_;
#line 43 "../src/Widgets/WifiMenuItem.vala"
	return result;
#line 1205 "WifiMenuItem.c"
}


static void
network_wifi_menu_item_class_init (NetworkWifiMenuItemClass * klass)
{
#line 18 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_type_class_adjust_private_offset (klass, &NetworkWifiMenuItem_private_offset);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_network_wifi_menu_item_get_property;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_network_wifi_menu_item_set_property;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (klass)->finalize = network_wifi_menu_item_finalize;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY] = g_param_spec_boxed ("ssid", "ssid", "ssid", G_TYPE_BYTES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY] = g_param_spec_enum ("state", "state", "state", NETWORK_TYPE_STATE, NETWORK_STATE_DISCONNECTED, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY] = g_param_spec_boolean ("active", "active", "active", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY] = g_param_spec_uchar ("strength", "strength", "strength", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NETWORK_WIFI_MENU_ITEM_AP_PROPERTY, network_wifi_menu_item_properties[NETWORK_WIFI_MENU_ITEM_AP_PROPERTY] = g_param_spec_object ("ap", "ap", "ap", nm_access_point_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 18 "../src/Widgets/WifiMenuItem.vala"
	network_wifi_menu_item_signals[NETWORK_WIFI_MENU_ITEM_USER_ACTION_SIGNAL] = g_signal_new ("user-action", NETWORK_TYPE_WIFI_MENU_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1234 "WifiMenuItem.c"
}


static void
network_wifi_menu_item_instance_init (NetworkWifiMenuItem * self)
{
#line 18 "../src/Widgets/WifiMenuItem.vala"
	self->priv = network_wifi_menu_item_get_instance_private (self);
#line 29 "../src/Widgets/WifiMenuItem.vala"
	self->priv->_state = NETWORK_STATE_DISCONNECTED;
#line 41 "../src/Widgets/WifiMenuItem.vala"
	self->priv->show_icons = TRUE;
#line 1247 "WifiMenuItem.c"
}


static void
network_wifi_menu_item_finalize (GObject * obj)
{
	NetworkWifiMenuItem * self;
#line 18 "../src/Widgets/WifiMenuItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 19 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_ap);
#line 44 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->_tmp_ap);
#line 46 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->radio_button);
#line 47 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->img_strength);
#line 48 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->lock_img);
#line 49 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->error_img);
#line 50 "../src/Widgets/WifiMenuItem.vala"
	_g_object_unref0 (self->priv->spinner);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	G_OBJECT_CLASS (network_wifi_menu_item_parent_class)->finalize (obj);
#line 1273 "WifiMenuItem.c"
}


GType
network_wifi_menu_item_get_type (void)
{
	static volatile gsize network_wifi_menu_item_type_id__volatile = 0;
	if (g_once_init_enter (&network_wifi_menu_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NetworkWifiMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) network_wifi_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NetworkWifiMenuItem), 0, (GInstanceInitFunc) network_wifi_menu_item_instance_init, NULL };
		GType network_wifi_menu_item_type_id;
		network_wifi_menu_item_type_id = g_type_register_static (gtk_list_box_row_get_type (), "NetworkWifiMenuItem", &g_define_type_info, 0);
		NetworkWifiMenuItem_private_offset = g_type_add_instance_private (network_wifi_menu_item_type_id, sizeof (NetworkWifiMenuItemPrivate));
		g_once_init_leave (&network_wifi_menu_item_type_id__volatile, network_wifi_menu_item_type_id);
	}
	return network_wifi_menu_item_type_id__volatile;
}


static void
_vala_network_wifi_menu_item_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_SSID_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_boxed (value, network_wifi_menu_item_get_ssid (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_enum (value, network_wifi_menu_item_get_state (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_boolean (value, network_wifi_menu_item_get_active (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STRENGTH_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_uchar (value, network_wifi_menu_item_get_strength (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_AP_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		g_value_set_object (value, network_wifi_menu_item_get_ap (self));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1332 "WifiMenuItem.c"
		default:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1338 "WifiMenuItem.c"
	}
}


static void
_vala_network_wifi_menu_item_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	NetworkWifiMenuItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NETWORK_TYPE_WIFI_MENU_ITEM, NetworkWifiMenuItem);
#line 18 "../src/Widgets/WifiMenuItem.vala"
	switch (property_id) {
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_STATE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_state (self, g_value_get_enum (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 18 "../src/Widgets/WifiMenuItem.vala"
		case NETWORK_WIFI_MENU_ITEM_ACTIVE_PROPERTY:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		network_wifi_menu_item_set_active (self, g_value_get_boolean (value));
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1365 "WifiMenuItem.c"
		default:
#line 18 "../src/Widgets/WifiMenuItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/Widgets/WifiMenuItem.vala"
		break;
#line 1371 "WifiMenuItem.c"
	}
}



